program cmd_oddface;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes,
  xmatdefs,
  uauxiliares,
  sysutils, process
  { you can add units after this };

(*** Resultado ejecuación ps a

Linux
  PID TTY      STAT   TIME COMMAND
 1806 tty1     Ss+    0:00 /sbin/getty 38400 tty1
 1807 tty2     Ss+    0:00 /sbin/getty 38400 tty2
 1808 tty3     Ss+    0:00 /sbin/getty 38400 tty3
 1809 tty4     Ss+    0:00 /sbin/getty 38400 tty4
 1810 tty5     Ss+    0:00 /sbin/getty 38400 tty5
 1811 tty6     Ss+    0:00 /sbin/getty 38400 tty6
10802 pts/0    Ss+    0:00 -bash
10969 pts/0    R     42:38 ./oddface_calibraparque 25 11
10970 pts/0    R     42:42 ./oddface_calibraparque 26 11
10971 pts/0    R     42:38 ./oddface_calibraparque 27 11
10972 pts/0    S     42:36 ./oddface_calibraparque 28 11
10973 pts/0    R     42:38 ./oddface_calibraparque 29 11
10974 pts/0    R     42:36 ./oddface_calibraparque 30 11
10975 pts/0    R     42:39 ./oddface_calibraparque 31 11
10976 pts/0    R     42:34 ./oddface_calibraparque 32 11
11275 pts/1    Ss     0:00 -bash
11346 pts/1    R+     0:00 ps a


***)

type
  TRobotRec = class
    pid: integer;
    stat: string;
    apl: string;
    idEjecutor: integer;
    idProblema: integer;
    constructor Create( comandline, spid, status: string );
    function cmdstr: string;
    procedure Kill_INT;
  end;

  TRobotLst = class( TList )
    constructor Create;
    procedure Free;
    procedure Show;
    procedure KillAll;
    procedure KillEjecutor( idEjecutor: integer );
    procedure DispatchNew( idProblema: integer );
  end;

  constructor TRobotRec.Create( comandline, spid, status: string );
  begin
    inherited Create;
    pid:= StrToInt( spid );
    self.stat:= status;
    apl:= nextPal( comandline );
    apl:= ExtractFileName( apl );
    idEjecutor:= nextInt( comandline );
    idProblema:= nextInt( comandline );
  end;

  procedure TRobotRec.Kill_INT;
  var
    s: string;
  begin
    writeln( 'killing ...'+cmdstr+'... ' );
    {$IFDEF LINUX}
    runCommand( 'kill -SIGINT '+intToStr( pid ), s );
    {$ELSE}
    runCommand( 'taskkill /T /PID '+intToStr( pid ), s ); //  - equivalent to kill -9 ncover*
    {$ENDIF}
  end;


  function TRobotRec.cmdstr: string;
  begin
    result:= apl+' '+IntToStr( idEjecutor )+ ' '+IntToStr( idProblema );
  end;

(* en windows:
WMIC  path win32_process get Processid,sessionid,kernelmodetime,status,commandline

CommandLine
KernelModeTime
ProcessId
SessionId
Status
              *)

constructor TRobotLst.Create;

var
  res: TList;
  s: string;
  r: string;
  aRec: TRobotRec;
  commandline, spid, status: string;
  iPid, nPid, iCL, nCL, iSts, nSts: integer;
begin
  inherited Create;
  {$IFDEF LINUX}
  runCommand( 'ps a', s );
  {$ELSE}
 // runCommand( 'tasklist /v', s  ); //  - equivalent to ps aux
 runCommand( 'WMIC  path win32_process get Processid,sessionid,kernelmodetime,status,commandline', s );
 {$ENDIF}

  r:= nextLine( s );

  {$IFDEF LINUX}
  iPid:= pos( 'PID', r );
  nPid:= pos( 'TTY', r ) - iPid;
  iSts:= pos( 'STAT', r );
  nSts:= pos( 'TIME', r ) - iSts;
  iCL:= pos( 'COMMAND', r );
  nCL:= length( r ) - iCL +1;
  {$ELSE}
  iPid:= pos( 'ProcessId', r );
  nPid:= pos( 'SessionId', r ) - iPid;
  iCL:= pos( 'CommandLine', r );
  nCL:= pos( 'KernelModeTime', r ) - iCL;
  iSts:= pos( 'Status', r );
  nSts:= length( r ) - iSts +1;
  {$ENDIF}

  while s <> '' do
  begin
    r:= nextLine( s );
    commandline:= trim( copy( r, iCL, nCL ) );
    writeln( commandline );
    {$IFDEF LINUX}
    if (pos( '/oddface_', r )) > 0and ( pos( ' ',r ) >  pos( '\oddface_', r ) )  then
    {$ELSE}
    if ( pos( '\oddface_', r ) > 0 ) and ( pos( ' ',r ) >  pos( '\oddface_', r ) ) then
    {$ENDIF}
    begin
      commandline:= trim( copy( r, iCL, nCL ) );
      spid:= trim( copy( r, iPid, nPid ) );
      status:= trim( copy( r, iSts, nSts ) );
      aRec:= TRobotRec.Create( commandline, spid, status );
      add( aRec );
    end;
  end;
end;

procedure TRobotLst.Show;
var
  k: integer;
  aRobot: TRobotRec;
begin
  writeln( 'idEjecutor':10, '|','idProblema':10,'|','apl' );
  for k:= 0 to Count-1 do
  begin
    aRobot:= TRobotRec( items[k] );
    writeln( aRobot.idEjecutor: 10, '|', aRobot.idProblema:10, '|', aRobot.apl );
  end;
end;

procedure TRobotLst.killAll;
var
  k: integer;
  aRobot: TRobotRec;
begin
  for k:= 0 to Count-1 do
  begin
    aRobot:= TRobotRec( items[k] );
    aRobot.Kill_INT;
  end;
end;

procedure TRobotLst.KillEjecutor( idEjecutor: integer );
var
  k: integer;
  buscando: boolean;
  aRobot: TRobotRec;
begin
  buscando:= true;
  for k:= 0 to Count-1 do
  begin
    aRobot:= TRobotRec( items[k] );
    if aRobot.idEjecutor = idEjecutor then
    begin
      aRobot.Kill_INT;
      buscando:= false;
      break;
    end;
  end;
  if buscando then writeln( 'No fue posible encontrar el ejecutor: '+IntToStr( idEjecutor ) );
end;

procedure TRobotLst.DispatchNew( idProblema: integer );
begin

end;

procedure TRobotLst.Free;
var
  k: integer;
  aRobot: TRobotRec;
begin
  for k:= 0 to Count-1 do
  begin
    aRobot:= TRobotRec( items[k] );
    aRobot.Free;
  end;
  inherited Free;
end;


var
  robots: TRobotLst;


procedure lanzar;
var
  Process: TProcess;
  I: Integer;
begin
  Process := TProcess.Create(nil);
  try
    Process.InheritHandles := False;
    Process.Options := [];
    (*
    Process.ShowWindow := swoShow;

    // Copy default environment variables including DISPLAY variable for GUI application to work
    for I := 1 to GetEnvironmentVariableCount do
      Process.Environment.Add(GetEnvironmentString(I));
      *)
    Process.Parameters.Add('12');
    Process.Parameters.Add('11');
    Process.Executable := 'C:/simsee/bin/oddface_CalibreParque.exe';
    Process.Execute;
  finally
    Process.Free;
  end;
end;

begin
  lanzar;
  robots:= TRobotLst.Create;
  robots.Show;
end.

