unit uListadoProblemas;

{$mode delphi}

interface

uses
  SysUtils, Classes, Controls,
  Forms,
  Graphics,
  urosx, uDataSetGenerico,
  StdCtrls, uvisordetabla,
  uempaquetar,
  uconstantesSimSEE, unotificar,
  u_updownload;

type

  { TListadoProblemas }

  TListadoProblemas = class ( TTabla )
    public
      flg_populate: boolean;
      dbcon: TDBrosxCon;
      constructor Create(dbconx: TDBrosxCon; AOwner: TComponent; Name: string ); reintroduce;
      procedure Borrar_OnClick( nidRec: string; kFila: integer ); override;
      procedure fdownload_OnClick(tbl_carpetas, tbl_archivos:string; nidRec: string; kFila: integer );
      procedure Paint; override;
      procedure Populate; virtual; abstract;
      class function CrearNuevoProblema: integer;virtual;abstract;
  end;



implementation
uses
  uoddface_prepare;

procedure CrearTabla_Inidviduos( dbcon: TDBrosxCon; nid_Problema: integer );
var
  sql: string;

begin
   sql := 'CREATE TABLE `ofe_individuos_'+ IntToStr( nid_problema )+'` ('
+'  `nid` int(11) NOT NULL,'
+'  `adn` varbinary( 800 ) NOT NULL,'
+'  `dtc` datetime NOT NULL,'
+'  `dtu` datetime NOT NULL,'
+'  `f_VE` double NOT NULL,'
+'  `f_CVaR` double NOT NULL,'
+'  `f_VaR` double NOT NULL,'
+'  `f_Objetivo` double NOT NULL,'
+'  `f_MIN` double NOT NULL,'
+'  `f_MAX` double NOT NULL,'
+'  `cnt_evaluaciones` int(11) NOT NULL,'
+'  `detalle` blob NOT NULL,'
+'  PRIMARY KEY  (`nid`),'
+'  UNIQUE KEY `iadn` (`adn`),'
+'  KEY `ifo` (`f_objetivo`)'
+') ENGINE=MyISAM DEFAULT CHARSET=latin1;';
 dbcon.sql_exec( sql );

end;


function eliminarProblema(dbcon: TDBrosxCon; nidCarpeta: string ): boolean;
var
  pathCarpeta: String;
  texto: String;
  sql: string;
begin
  result:= false;
  pathCarpeta:= dbcon.sql_func('SELECT path FROM ofe_carpetas WHERE nid = ' + nidCarpeta + ' LIMIT 1');

  texto:= '¿Confirma que desea eliminar el Problema: ' + nidCarpeta + ' con todos sus archivos?';

  if confirmar( texto, ['Si', 'No' ] ) = 'Si' then
  begin
    sql:= 'DELETE FROM ofe_archivos WHERE nid_carpeta = ' + nidCarpeta;
    if not dbcon.sql_exec( sql ) then
      raise Exception.Create( dbcon.UltimoError );

    sql:= 'DELETE FROM ofe_carpetas WHERE nid = ' + nidCarpeta;
    if not dbcon.sql_exec( sql ) then
      raise Exception.Create( dbcon.UltimoError );

    sql:= 'DROP TABLE ofe_individuos_'+  nidCarpeta ;
    dbcon.sql_exec( sql );
//      raise Exception.Create( urosx.UltimoError );



   sql:= 'DELETE FROM ofe_PIG_tecnologias WHERE nid_problema = ' + nidCarpeta;
   if not dbcon.sql_exec( sql ) then
    raise Exception.Create( dbcon.UltimoError );


   sql:= 'DELETE FROM ofe_PAM_ordenes WHERE nid_problema = ' + nidCarpeta;
   if not dbcon.sql_exec( sql ) then
    raise Exception.Create( dbcon.UltimoError );

   sql:= 'DELETE FROM ofe_RedCEGH_data WHERE nid_problema = ' + nidCarpeta;
   if not dbcon.sql_exec( sql ) then
    raise Exception.Create( dbcon.UltimoError );


    sql:= 'DELETE FROM ofe_problemas WHERE nid = ' + nidCarpeta;
    if not dbcon.sql_exec( sql ) then
      raise Exception.Create( dbcon.UltimoError );

    result:= true;
  end
end;



constructor TListadoProblemas.Create(dbconx: TDBrosxCon; AOwner: TComponent;
  Name: string);
begin
  inherited Create(AOwner, Name, 4, 1, 0 );
  dbcon:= dbconx;
  flg_populate:= true;
end;

procedure TListadoProblemas.Paint;
begin
  if flg_populate then Populate;
  inherited Paint;
end;

procedure TListadoProblemas.Borrar_OnClick( nidRec: string; kFila: integer );
begin
  eliminarProblema( dbcon, nidRec );
  flg_populate:= true;
  Invalidate;
  //  Populate; // prefiero polular
end;

procedure TListadoProblemas.fdownload_OnClick(tbl_carpetas,
  tbl_archivos: string; nidRec: string; kFila: integer);
var
  res_ok: boolean;
begin
  unotificar.esperando_inicio( 'bajando carpeta' );
  res_ok:= bajarCarpeta( dbcon, tbl_carpetas, tbl_archivos, StrToInt( nidRec ) );
  unotificar.esperando_fin;
  if res_ok then
   unotificar.notificar( 'La carpeta fue bajada exitosamente.')
  else
   unotificar.notificar( u_updownload.UltimoError, true);
end;

end.

