unit uDemandaConRespuesta;

{$mode delphi}

interface

uses
  Classes, SysUtils, xmatdefs, math;

// Demanda Con Respuesta
procedure CDR_MW(
  var DCR_MW: TDAOFNReal; // Retorna la demanda en MW hora a hora.
  cmg_pe10, cmg_ve, cmg_pe90: TDAofNReal; // INformación de costos marginales hora a hora.
  dtInicioDelTramo: TDateTime );


implementation
const
  dt_1Hora = 1.0/24.0;


function GetTipoDia( dt: TDateTime ): integer; // 1 domingo - 7 sábado
begin
  result:= DayOfWeek( dt );
end;

function GetHora( dt: TDateTime): integer; // 0..23 las horas
begin
  result:= trunc( frac( dt ) * 24.0 + 0.01 );
end;

procedure CDR_MW(
  var DCR_MW: TDAOFNReal; // Retorna la demanda en MW hora a hora.
  cmg_pe10, cmg_ve, cmg_pe90: TDAofNReal; // INformación de costos marginales hora a hora.
  dtInicioDelTramo: TDateTime );
var
  k: integer;
  dt: TDateTime;
  TipoDia: integer;
  hora: integer;
  AD, AH: NReal;

begin
  for k:= 0 to high( DCR_MW ) do
  begin
    dt:= dtInicioDelTramo + k * dt_1Hora;
    TipoDia:= getTipoDia( dt );
    hora:= getHora( dt );
    case TipoDia of
      1: AD:= 0.5;
      2..6: AD:= 1.0;
      7: AD:= 0.8;
    end;
    case hora of
      8..17: AH:= 1.0;
      18..23: AH := 1.5;
      else
        AH:= 0.7;
    end;
    DCR_MW[k]:= ( 300 - (cmg_ve[k] - 100) )*AH*AD;
  end;
end;

end.

