 {xDEFINE PERTURBADO}
 {xDEFINE CHEQUEOMEM}
 {xDEFINE ESTABILIZAR_FRAMEINICIAL}
{$DEFINE SPXMEJORCAMINO}
{$IFNDEF SUPRIMIR_DUMP_TEXT}
  {$DEFINE DUMP_TEXT_SIMRES}
  {$DEFINE DUMP_TEXT_OPTRES}
{$ENDIF}
unit usalasdejuego;

{$IFDEF FPC}
{$MODE Delphi}
{$ENDIF}

interface

uses
{$IFDEF CHEQUEOMEM}
  udbgutil,
{$ENDIF}
  Classes, SysUtils,
  Math,
  uglobs,
  uconstantesSimSEE,
  xmatdefs,
{$IFDEF MIPSimplex}
 {$IFDEF SPXMEJORCAMINO}
  umipsimplex_mejorcamino,
 {$ELSE}
  umipsimplex,
 {$ENDIF}
{$ELSE}
  usimplex,
{$ENDIF}
  uActores, ucosa, uCosaConNombre,
  ufechas,
  uDemandas,
  uGeneradores, uGTer,
  uArcos,
  uNodos,
  uMercadoSpot,
  uEstados,
  uFuentesAleatorias,
  uCombustible,
  uodt_types,
  fddp,
{$IFNDEF FPC}
  shellapi,
{$ELSE}
  //  FileUtil,
{$ENDIF}
  upreprocesador,
  uEsclavizador,
  uEsclavizadorSobreMuestreado,
{$IFDEF WIN32}
  {$IFDEF FPCLCL}
  LCLIntf, lcltype,
  {$ELSE}
  Windows,
  {$ENDIF}
{$ELSE}
{$ENDIF}
  uEsclavizadorSubMuestreado,
  uAuxiliares,
  uHidroConBombeo,
  uversiones;

(*
const // OJO no poner estos string como resourcestrings pues son constantes.
  csGlobs = 'Globs';
  csGeneradores = 'Generadores';
  csDemandas = 'Demandas';
  csNodos = 'Nodos';
  csArcos = 'Arcos';
  csComercioInternacional = 'Comercio Internacional';
  csListaActores = 'Lista de Actores';
  csFuentesAleatorias = 'Fuentes Aleatorias';
  csEnganchesContinuos = 'EnganchesContinuos';
  csEnganchesDiscretos = 'EnganchesDiscretos';
  csFuentesReemplazadas = 'FuentesReemplazadas';
  csCombustibles = 'Combustibles';
*)
type
  TDAOfTextFile = array of TextFile;

  TSalaDeJuego = class(TCosaParticipeDeMercado)
  private
    //Variables publicadas en la simulacin
    costoDirectoDelpaso: NReal;
    // tiene el acumulado de los actores. Se carga en LeerSolucion de la Sala
    costoDelPaso, CF_AlInicioDelPaso, CFaux_AlInicioDelPaso: NReal;
  public
    globs: TGlobs;

    // listas de todos los actores en el escenario
    listaActores:      TListaDeCosasConNombre; {of TActor}
    // lista de todas las fuentes en el escenario
    listaFuentes:      TListaDeCosasConNombre; {of IFuenteAleatoria}
    //Contiene las fuentes que hayan sido reemplazadas por algn esclavizador
    listaFuentesReemplazadas: TListaDeCosasConNombre;
    listaCombustibles: TListaDeCosasConNombre; {of TCombustible}

    // Listas para soporte clasificado de los actores
    Nods: TListaDeCosasConNombre {of INodo};
    Arcs: TListaDeCosasConNombre {of IArco};
    Gens: TListaDeCosasConNombre {of TGenerador};
    Dems: TListaDeCosasConNombre {of IDemanda};
    ComercioInternacional: TListaDeCosasConNombre {of TComercioInternacional};

    // listas auxiliares para acelerar los barridos
    lst_barridoFijarEstadoDeActoresToEstrella: TList;
    lst_barridoFijarEstadoDeFuentesToEstrella: TList;
    lst_SorteosDelPaso_Actores: array of TActor;
    lst_opt_PrintResultados:    TList;
    lst_Sim_cronicaIdInicio:    TList;

    lst_actores_evolucionarEstado: TList;
    lst_fuentes_evolucionarEstado: TList;

    //      lst_actores_costoDirectoDelPaso: TList;
    lst_fuentes_costoDirectoDelPaso: TList;

    lst_Sim_Paso_Fin: TList;
{$IFDEF ITERAR}
    lst_NecesitoIterar: TList;
{$ENDIF}
    termicos: array of TGter;
    actores:  array of TActor;
    fuentes:  array of TFuenteAleatoria;
    combustibles: array of TCombustible;

    //Se arman en optx_nvxs. Si la fuente original es sub_muestreada el arreglo
    //contiene el esclavizador
    fuentesConBCSinEstadoEnCF: array of TFuenteAleatoria;
    //subConjunto del arreglo fuentes de las fuentes que no registran estado en CF y tienen bornes calculados. Pueden tener variables de estado internas
    fuentesConBCConEstadoEnCF: array of TFuenteAleatoria;
    //subConjunto del arreglo fuentes de las fuentes que registran su estado en CF y tienen bornes calculados
    hidraulicos: array of TGeneradorHidraulico;

    // contadores de variables para el registro de variables por los actores
    // conjunto de variables asociadas con el planteo del Simplex.
    ivar: integer; // Contador de variables de optimizacin
    ires: integer; // Contador de restricciones
    ivae: integer; // Contador de variables Enteras en el problema de optimizacin

    // contadores de variables para el registro de variables por los actores
    // conjunto de variables asociadas con el espacio de estados.
    ivar_xr:     integer; // Contador de variables de estado continuas
    ivar_xd:     integer; // Contador de varialbes de estado discretas
    ivar_auxNReal: integer; // Contador de variables auxiliares de estado contnuas
    ivar_auxInt: integer; // Contador de variables auxiliares de estado discretas

{$IFDEF MIPSimplex}
    spx: TMIPSimplex;
{$ELSE}
    spx: TSimplex;
{$ENDIF}

    descripcion: string;
    archiSala:   string; //El archivo de la sala de juego
    dirSala:     string; // directorio del archiSala
    dirResultadosCorrida: string;
    //El directorio donde se van a salvar los resultados de
    //la corrida. Por defecto es uconstantes.getDir_bin+'/nombresala'

    estabilizarInicio: boolean;
    usarArchivoParaInicializarFrameInicial: boolean;

    //El archivo desde el que se va cargar los datos para inicializar el frame inicial
    archivoCF_ParaEnganches: string;
    archivoSala_ParaEnganches: string;
    engancharConSala: boolean; //Si es true, el radio button seleccionado es el de sala

    // si est definido es que queremos ir mirando durante la simulacin por
    // donde vamos en esta funcin de Costo Futuro Auxiliar.
    archivoCFAux: string;

    escribirOptActores: boolean;

    //Los valores en los que se quiere inicializar las variables del CF archivoCF
    //que no esten en el CF de esta sala
    enganchesContinuos, enganchesDiscretos: TListaDeCosas;

    HayQueIterar_: boolean; // Variable auxiliar que determina si es necesario iterar
    // para una mejor resolucin del paso de tiempo.

    //      modoImprimirPotenciasFirmes: boolean;
    RandSeedInicial: integer;
    RandSeed_SincronizarAlInicioDeCadaCronica: boolean;

    constructor Create(nombre: string;
      fechaIniSim, fechaFinSim, fechaIniOpt, fechaFinOpt: TFecha; DurPos: TDAOfNReal); reintroduce;
    constructor Create_ReadFromText(f: TArchiTexto); override;
    constructor cargarSala(archiSala: string; abortarEnError: boolean);

    procedure WriteToText(f: TArchiTexto); override;
    procedure Free; override;

    procedure PubliVars; override;

    procedure setDirCorrida(archivoSala: string);

    //Crea los arreglos de actores
    procedure Prepararse(TiempoHaciaAdelante: boolean);
    procedure PrepararseYPubliVars(lista: TListaDeCosasConNombre); overload;
    procedure PrepararseYPubliVars; overload;

    // Determina la dimensin del espacio de estado y los frames
    // de variables auxiliares que sea necesario crear.
    procedure optx_nvxs;

    // retorna la suma de variables de estado primero llama a optx_nvxs
    function ContarVariablesDeEstado: integer;
    function generarResumenTermicoPrimerasFichas: string;

    procedure Simular;



    procedure Sim_Cronica_Inicio;

    procedure Actores_AcumularAuxs1;
    procedure Actores_SetAuxs1;

    procedure SorteosDelPasoOpt(sortear: boolean);
    procedure SorteosDelPasoSim(sortear: boolean);

    // este mtodo sellama luego de los sorteos del  paso
    // y antes de preparar los actores.
    procedure Fuentes_PrepararPaso_ps;

    // este mtodo se llama luego de los sorteos del  paso y luego
    // de que las fuentes se prepararon.
    // Si hay iteraciones puede ocurrir que ese mtodo se llame reiteradas veces.
    procedure Actores_PrepararPaso_ps;

    procedure PrepararPaso_as;

    function ResolverPaso: NReal; // retorna el costo en USD

    procedure EvolucionarEstado;
    procedure Sim_Paso_Fin;
    procedure CapturarResultadosDelPaso;
    procedure Sim_Cronica_Fin;
    procedure FinSimulacion;

    function CostoDelPaso_masCF_llegada: NReal;
    procedure Optimizar;

    procedure inicializarArchisOptRes(var fsal: TextFile;
      var fsal_opt: TDAOfTextFile; var fsalopen: boolean);
    procedure escribirPasoOptRes(var fsal: TextFile; var fsal_opt: TDAOfTextFile);
    procedure cerrarArchisOptRes(var fsal: TextFile; var fsal_opt: TDAOfTextFile;
      var fsalopen: boolean);

    procedure printEncabezadoSimRes(var f: TextFile);
    procedure printFinalSimRes(var f: TextFile);

{$IFDEF ESTABILIZAR_FRAMEINICIAL}
    procedure EstabilizarFrameInicial;
{$ENDIF}
    procedure FinOptimizacion;

    //Reordena la lista de fuentes para que si una fuente usa un valor de otra
    //entonces el valor de la otra se calcule antes
    procedure ordenarFuentes;

    procedure Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
    procedure Armar_lst_SorteosDelPaso_Actores;

    procedure Armar_lst_opt_PrintResultados;
    procedure Armar_lst_Sim_cronicaIdInicio;
    procedure armar_lst_Sim_Paso_Fin;

    procedure Armar_lst_EvolucionarEstado;
    procedure Armar_lst_costoDirectoDelPaso;

{$IFDEF ITERAR}
    procedure Armar_lst_necesitoIterar;
    function NecesitoIterar: boolean;
{$ENDIF}
    //      procedure Armar_lst_Encadenamientos;
    procedure PosicionarseEnEstrellita;
    procedure ActualizarEstadoGlobal;
    function getNombreVar(ivar: integer): string;
    function getNombreRes(ires: integer): string;
    procedure dump_Variables; overload;
    procedure dump_Variables(archi: string); overload;
    procedure ImprimirPotenciasFirmes;

    procedure inicializarOptimizacion(const costoFuturo: TMatOfNReal);
    procedure calcularRangoEstrellas(estrellaIni, estrellaFin: integer);

    //Para debug
    function genStrPasoCronEstrIter: string;//Optimizacion
    function genStrCronPasoIter: string;//Simulacion
  end;

procedure AlInicio;
procedure AlFinal;


implementation


constructor TSalaDeJuego.Create(nombre: string;
  fechaIniSim, fechaFinSim, fechaIniOpt, fechaFinOpt: TFecha; DurPos: TDAOfNReal);
begin
  inherited Create(nombre);
  Globs := TGlobs.Create('globs', fechaIniSim, fechaFinSim, fechaIniOpt,
    fechaFinOpt, DurPos);
  Gens  := TListaDeCosasConNombre.Create('gens');
  Dems  := TListaDeCosasConNombre.Create('dems');
  Nods  := TListaDeCosasConNombre.Create('nods');
  Arcs  := TListaDeCosasConNombre.Create('arcs');
  ComercioInternacional := TListaDeCosasConNombre.Create('ComercioInternacional');

  listaActores      := TListaDeCosasConNombre.Create('Lista de Actores');
  listaFuentes      := TListaDeCosasConNombre.Create('listaFuentes');
  listaFuentesReemplazadas := TListaDeCosasConNombre.Create('FuentesReemplazadas');
  listaCombustibles := TListaDeCosasConNombre.Create('Combustibles');

  enganchesContinuos := TListaDeCosas.Create('enganchesContinuos');
  enganchesDiscretos := TListaDeCosas.Create('enganchesDiscretos');

  spx := nil;
  dirResultadosCorrida := getDir_Run;
  estabilizarInicio := False;
  usarArchivoParaInicializarFrameInicial := False;
  archivoCF_ParaEnganches := '';
  self.escribirOptActores := False;

  RandSeed_SincronizarAlInicioDeCadaCronica := True;
end;

constructor TSalaDeJuego.Create_ReadFromText(f: TArchiTexto);
var
  i:   integer;
  durPosAux: TDAofNReal;
  funcsBasura: TListaDeCosasConNombre;
  pal: string;

begin
  inherited Create_ReadFromText(f);

  RandSeed_SincronizarAlInicioDeCadaCronica := True;

  spx := nil;
  estabilizarInicio := False;
  usarArchivoParaInicializarFrameInicial := False;
  archivoCF_ParaEnganches := '';

  self.escribirOptActores := False;
  self.archiSala := f.nombreArchivo;
  pal := SysUtils.ExtractFileName(archiSala);
  i   := pos('.', pal);
  if i > 0 then
    Delete(pal, i, length(pal) - i + 1);
  if uConstantesSimSEE.tmp_rundir = '' then
    dirResultadosCorrida := getDir_Run + pal + barraDir
  else
    dirResultadosCorrida := tmp_rundir;


  if f.Version < 4 then
  begin
    f.IniciarLecturaRetrasada;
    f.rd('descripcion', descripcion);
    f.rd('globs', TCosa(globs));
    f.rd('gens', TCosa(gens));
    f.rd('dems', TCosa(dems));
    f.rd('nods', TCosa(nods));
    f.rd('arcs', TCosa(arcs));
    f.rd('spots', TCosa(ComercioInternacional));
    f.rd('listaFuentes', TCosa(listaFuentes));
    f.rd('funcs', TCosa(funcsBasura));
    f.rd('estabilizarInicio', estabilizarInicio);
    f.rd('usarArchivoParaInicializarFrameInicial',
      usarArchivoParaInicializarFrameInicial);
    f.rdArch('archivoCF', archivoCF_ParaEnganches);
    f.rd('enganchesContinuos', TCosa(enganchesContinuos));
    f.rd('enganchesDiscretos', TCosa(enganchesDiscretos));

    f.EjecutarLectura;
    spx := nil;

    if globs = nil then
    begin
      SetLength(durPosAux, 1);
      globs := TGlobs.Create('globs', TFecha.Create_Dt(0), TFecha.Create_Dt(0),
        TFecha.Create_Dt(0), TFecha.Create_Dt(0), durPosAux);
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudieron leer las variables globales. Asignando valores por defecto.');
    end;
    if gens = nil then
    begin
      gens := TListaDeCosasConNombre.Create('gens');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de generadores. Asignando la lista vaca.');
    end;
    if nods = nil then
    begin
      nods := TListaDeCosasConNombre.Create('nods');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de nodos. Asignando la lista vaca.');
    end;
    if dems = nil then
    begin
      dems := TListaDeCosasConNombre.Create('dems');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de demandas. Asignando la lista vaca.');
    end;
    if Arcs = nil then
    begin
      Arcs := TListaDeCosasConNombre.Create('arcs');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de arcos. Asignando la lista vaca.');
    end;

    if ComercioInternacional = nil then
    begin
      ComercioInternacional := TListaDeCosasConNombre.Create('Comercio Internacional');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de spots de mercado. Asignando la lista vaca.');
    end;



    if listaFuentes = nil then
    begin
      listaFuentes := TListaDeCosasConNombre.Create('fuentes');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de fuentes. Asignando la lista vaca.');
    end;
    if enganchesContinuos = nil then
    begin
      enganchesContinuos := TListaDeCosas.Create('EnganchesContinuos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Continuos. Asignando la lista vaca.');
    end;
    if enganchesDiscretos = nil then
    begin
      enganchesDiscretos := TListaDeCosas.Create('EnganchesDiscretos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Discretos. Asignando la lista vaca.');
    end;

    listaActores := TListaDeCosasConNombre.Create('Lista de Actores');
    listaActores.Capacity := gens.Count + dems.Count + nods.Count + arcs.Count;
    for i := 0 to nods.Count - 1 do
      listaActores.Add(TCosaConNombre(nods[i]));
    for i := 0 to dems.Count - 1 do
      listaActores.Add(TCosaConNombre(dems[i]));
    for i := 0 to gens.Count - 1 do
      listaActores.Add(TCosaConNombre(gens[i]));
    for i := 0 to arcs.Count - 1 do
      listaActores.Add(TCosaConNombre(arcs[i]));
    for i := 0 to ComercioInternacional.Count - 1 do
      listaActores.Add(TCosaConNombre(ComercioInternacional[i]));
    if funcsBasura <> nil then
      funcsBasura.Free;
    listaFuentesReemplazadas := TListaDeCosasConNombre.Create('FuentesReemplazadas');
  end
  else if f.Version < 9 then
  begin
    f.IniciarLecturaRetrasada;
    f.rd('descripcion', descripcion);
    f.rd('globs', TCosa(globs));
    f.rd('gens', TCosa(gens));
    f.rd('dems', TCosa(dems));
    f.rd('nods', TCosa(nods));
    f.rd('arcs', TCosa(arcs));
    f.rd('ComercioInternacional', TCosa(ComercioInternacional));
    f.rd('listaFuentes', TCosa(listaFuentes));
    f.rd('funcs', TCosa(funcsBasura));
    f.rd('estabilizarInicio', estabilizarInicio);
    f.rd('usarArchivoParaInicializarFrameInicial',
      usarArchivoParaInicializarFrameInicial);
    f.rdArch('archivoCF', archivoCF_ParaEnganches);
    f.rd('enganchesContinuos', TCosa(enganchesContinuos));
    f.rd('enganchesDiscretos', TCosa(enganchesDiscretos));

    f.EjecutarLectura;
    spx := nil;

    if globs = nil then
    begin
      SetLength(durPosAux, 1);
      globs := TGlobs.Create('globs', TFecha.Create_Dt(0), TFecha.Create_Dt(0),
        TFecha.Create_Dt(0), TFecha.Create_Dt(0), durPosAux);
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudieron leer las variables globales. Asignando valores por defecto.');
    end;
    if gens = nil then
    begin
      gens := TListaDeCosasConNombre.Create('gens');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de generadores. Asignando la lista vaca.');
    end;
    if nods = nil then
    begin
      nods := TListaDeCosasConNombre.Create('nods');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de nodos. Asignando la lista vaca.');
    end;
    if dems = nil then
    begin
      dems := TListaDeCosasConNombre.Create('dems');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de demandas. Asignando la lista vaca.');
    end;
    if Arcs = nil then
    begin
      Arcs := TListaDeCosasConNombre.Create('arcs');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de arcos. Asignando la lista vaca.');
    end;
    if ComercioInternacional = nil then
    begin
      ComercioInternacional := TListaDeCosasConNombre.Create('Comercio Internacional');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de spots de mercado. Asignando la lista vaca.');
    end;
    if listaFuentes = nil then
    begin
      listaFuentes := TListaDeCosasConNombre.Create('fuentes');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de fuentes. Asignando la lista vaca.');
    end;

    if enganchesContinuos = nil then
    begin
      enganchesContinuos := TListaDeCosas.Create('EnganchesContinuos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Continuos. Asignando la lista vaca.');
    end;
    if enganchesDiscretos = nil then
    begin
      enganchesDiscretos := TListaDeCosas.Create('EnganchesDiscretos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Discretos. Asignando la lista vaca.');
    end;

    listaActores := TListaDeCosasConNombre.Create('Lista de Actores');
    listaActores.Capacity := gens.Count + dems.Count + nods.Count + arcs.Count;
    for i := 0 to nods.Count - 1 do
      listaActores.Add(TCosaConNombre(nods[i]));
    for i := 0 to dems.Count - 1 do
      listaActores.Add(TCosaConNombre(dems[i]));
    for i := 0 to gens.Count - 1 do
      listaActores.Add(TCosaConNombre(gens[i]));
    for i := 0 to arcs.Count - 1 do
      listaActores.Add(TCosaConNombre(arcs[i]));
    for i := 0 to ComercioInternacional.Count - 1 do
      listaActores.Add(TCosaConNombre(ComercioInternacional[i]));

    if funcsBasura <> nil then
      funcsBasura.Free;
    listaFuentesReemplazadas := TListaDeCosasConNombre.Create('FuentesReemplazadas');
  end
  else
  begin
    f.IniciarLecturaRetrasada;
    f.rd('descripcion', descripcion);
    f.rd('globs', TCosa(globs));
    f.rd('gens', TCosa(gens));
    f.rd('dems', TCosa(dems));
    f.rd('nods', TCosa(nods));
    f.rd('arcs', TCosa(arcs));
    f.rd('ComercioInternacional', TCosa(ComercioInternacional));

    f.rd('listaFuentes', TCosa(listaFuentes));
    f.rd('estabilizarInicio', estabilizarInicio);
    f.rd('usarArchivoParaInicializarFrameInicial',
      usarArchivoParaInicializarFrameInicial);

    if f.Version < 46 then
      f.rdArch('archivoCF', archivoCF_ParaEnganches);

    if f.Version >= 46 then
    begin
      f.rdArch('archivoCF_ParaEnganches', archivoCF_ParaEnganches);
      f.rdArch('archivoSala_ParaEnganches', archivoSala_ParaEnganches);
      f.rd('engancharConSala', engancharConSala);
    end;

    if f.Version >= 33 then
      f.rdArch('archivoCFaux', archivoCFaux);

    f.rd('enganchesContinuos', TCosa(enganchesContinuos));
    f.rd('enganchesDiscretos', TCosa(enganchesDiscretos));

    if (f.version < 54) then
      listaCombustibles := TListaDeCosasConNombre.Create('Combusitbles')
    else
      f.rd('Combustibles', TCosa(listaCombustibles));

    f.EjecutarLectura;
    spx := nil;

    if globs = nil then
    begin
      SetLength(durPosAux, 1);
      globs := TGlobs.Create('globs', TFecha.Create_Dt(0), TFecha.Create_Dt(0),
        TFecha.Create_Dt(0), TFecha.Create_Dt(0), durPosAux);
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudieron leer las variables globales. Asignando valores por defecto.');
    end;
    if gens = nil then
    begin
      gens := TListaDeCosasConNombre.Create('gens');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de generadores. Asignando la lista vaca.');
    end;
    if nods = nil then
    begin
      nods := TListaDeCosasConNombre.Create('nods');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de nodos. Asignando la lista vaca.');
    end;
    if dems = nil then
    begin
      dems := TListaDeCosasConNombre.Create('dems');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de demandas. Asignando la lista vaca.');
    end;
    if Arcs = nil then
    begin
      Arcs := TListaDeCosasConNombre.Create('arcs');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de arcos. Asignando la lista vaca.');
    end;
    if ComercioInternacional = nil then
    begin
      ComercioInternacional := TListaDeCosasConNombre.Create('Comercio Internacional');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de spots de mercado. Asignando la lista vaca.');
    end;

    if listaFuentes = nil then
    begin
      listaFuentes := TListaDeCosasConNombre.Create('fuentes');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de fuentes. Asignando la lista vaca.');
    end;

    if enganchesContinuos = nil then
    begin
      enganchesContinuos := TListaDeCosas.Create('EnganchesContinuos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Continuos. Asignando la lista vaca.');
    end;
    if enganchesDiscretos = nil then
    begin
      enganchesDiscretos := TListaDeCosas.Create('EnganchesDiscretos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Discretos. Asignando la lista vaca.');
    end;

    listaActores := TListaDeCosasConNombre.Create('Lista de Actores');
    listaActores.Capacity := gens.Count + dems.Count + nods.Count + arcs.Count;
    for i := 0 to nods.Count - 1 do
      listaActores.Add(TCosaConNombre(nods[i]));
    for i := 0 to dems.Count - 1 do
      listaActores.Add(TCosaConNombre(dems[i]));
    for i := 0 to gens.Count - 1 do
      listaActores.Add(TCosaConNombre(gens[i]));
    for i := 0 to arcs.Count - 1 do
      listaActores.Add(TCosaConNombre(arcs[i]));
    for i := 0 to ComercioInternacional.Count - 1 do
      listaActores.Add(TCosaConNombre(ComercioInternacional[i]));

    listaFuentesReemplazadas := TListaDeCosasConNombre.Create('FuentesReemplazadas');

  end;
end;

constructor TSalaDeJuego.cargarSala(archiSala: string; abortarEnError: boolean);
var
  f:   TArchiTexto;
  aux: TListaDeCosasConNombre;
begin
  if FileExists(archiSala) { *Converted from FileExists*  } then
  begin
    f   := TArchiTexto.CreateForRead(archiSala, abortarEnError);
    aux := TListaDeCosasConNombre.Create('aux');
    try
      f.rd('sala', TCosa(self));
      f.Free;
      f := nil;

      //Resolver referencias
      if uCosaConNombre.referenciasSinResolver > 0 then
      begin
        aux.Add(globs);
        uCosaConNombre.resolver_referencias(aux);
        uCosaConNombre.resolver_referencias(listaActores);
        uCosaConNombre.resolver_referencias(listaFuentes);
        uCosaConNombre.resolver_referencias(listaCombustibles);
        aux.FreeSinElemenentos;
        aux := nil;
      end;
      if uCosaConNombre.referenciasSinResolver > 0 then
      begin
        uCosaConNombre.DumpReferencias('errRefs.txt');
        raise Exception.Create(
          'TSalaDeJuego.cargarSala: Quedaron Referencias Sin Resolver Cargando la Sala. Puede Ver Que Referencias No Se Resolvieron En: '
          +
          'errRefs.txt');
      end;
      self.setDirCorrida(archiSala);
    except
      if aux <> nil then
        aux.Free;
      if f <> nil then
        f.Free;
      raise;
    end;
  end
  else
    raise Exception.Create('TSalaDeJuego.cargarSala: no se encuentra el archivo ' +
      archiSala);
end;

procedure TSalaDeJuego.WriteToText(f: TArchiTexto);
begin
  inherited WriteToText(f);
  f.wr('descripcion', descripcion);
  f.writeline('');
  f.wr('globs', globs);
  f.writeline('');
  f.wr('gens', gens);
  f.writeline('');
  f.wr('dems', dems);
  f.writeline('');
  f.wr('nods', nods);
  f.writeline('');
  f.wr('arcs', arcs);
  f.writeline('');
  f.wr('ComercioInternacional', ComercioInternacional);
  f.writeline('');

  f.wr('listaFuentes', listaFuentes);
  f.wr('Combustibles', listaCombustibles);

  f.wr('estabilizarInicio', estabilizarInicio);
  f.wr('usarArchivoParaInicializarFrameInicial',
    usarArchivoParaInicializarFrameInicial);

  f.wrArch('archivoCF_ParaEnganches', quitarRaiz(archivoCF_ParaEnganches));
  f.wrArch('archivoSala_ParaEnganches', quitarRaiz(archivoSala_ParaEnganches));
  f.wr('engancharConSala', engancharConSala);
  f.wrArch('archivoCFaux', quitarRaiz(archivoCFaux));

  f.wr('enganchesContinuos', TCosa(enganchesContinuos));
  f.wr('enganchesDiscretos', TCosa(enganchesDiscretos));
  self.archiSala := f.nombreArchivo;
end;

procedure TSalaDeJuego.Free;
begin
  Gens.Free;
  Dems.Free;
  Nods.Free;
  Arcs.Free;
  ComercioInternacional.Free;
  listaActores.FreeSinElemenentos;
  listaFuentes.Free;
  listaFuentesReemplazadas.FreeSinElemenentos;
  if lst_barridoFijarEstadoDeActoresToEstrella <> nil then
    lst_barridoFijarEstadoDeActoresToEstrella.Free;
  if lst_barridoFijarEstadoDeFuentesToEstrella <> nil then
    lst_barridoFijarEstadoDeFuentesToEstrella.Free;
  if lst_opt_PrintResultados <> nil then
    lst_opt_PrintResultados.Free;
  if lst_Sim_cronicaIdInicio <> nil then
    lst_Sim_cronicaIdInicio.Free;

  if lst_actores_evolucionarEstado <> nil then
    lst_actores_evolucionarEstado.Free;
  if lst_fuentes_evolucionarEstado <> nil then
    lst_fuentes_evolucionarEstado.Free;

{$IFDEF ITERAR}
  if lst_NecesitoIterar <> nil then
    lst_NecesitoIterar.Free;
{$ENDIF}

(*
  if lst_actores_costoDirectoDelPaso <> NIL then
    lst_actores_costoDirectoDelPaso.Free;
  *)
  if lst_fuentes_costoDirectoDelPaso <> nil then
    lst_fuentes_costoDirectoDelPaso.Free;

  if lst_Sim_Paso_Fin <> nil then
    lst_Sim_Paso_Fin.Free;
  if spx <> nil then
{$IFDEF MIPSimplex}
    spx.Free;
{$ELSE}
  spx.Free(True);
{$ENDIF}
  Globs.Free;
  SetLength(actores, 0);
  SetLength(fuentes, 0);
  SetLength(hidraulicos, 0);
  SetLength(termicos, 0);
  SetLength(combustibles, 0);

  if enganchesContinuos <> nil then
    enganchesContinuos.Free;
  if enganchesDiscretos <> nil then
    enganchesDiscretos.Free;
  inherited Free;
end;

procedure TSalaDeJuego.PubliVars;
begin
  inherited PubliVars;
  PublicarVariableNR('CF_AlInicioDelPaso', '[USD]', 12, 1, CF_AlInicioDelPaso, True);
  PublicarVariableNR('CPSimplex', '[USD]', 12, 1, costoDelPaso, True);
  PublicarVariableNR('CPDirecto', '[USD]', 12, 1, costoDirectoDelPaso, True);
  //Es de globs, pero se imprime en la sala por separado
  //PublicarVariableNR('cntIterPaso', '-', 12, 1, cntIterPaso, true);
  PublicarVariableNR('CFaux', '[USD]', 12, 1, CFaux_AlInicioDelPaso, ArchivoCFAux <> '');
end;

procedure TSalaDeJuego.setDirCorrida(archivoSala: string);
var
  i, j:     integer;
  nombreArchivo: string;
  buscando: boolean;

begin
  j := length(archivoSala);
  i := j + 1;

  buscando := True;
  while buscando and (j > 0) do
  begin
    if archivoSala[j] = barraDir then
      buscando := False
    else
    begin
      // si encontramos un punto antes de la primer barra de directorio
      // anotamos su posicin en i
      if (archivoSala[j] = '.') then
        i := j;
      Dec(j);
    end;
  end;

  if buscando then
  begin
    // archivoSala est en la raiz del disco.
    dirSala := '';
    j := 0;
  end
  else
  begin
    dirSala := copy(archivoSala, 1, j - 1) + barraDir;
  end;
  nombreArchivo := copy(archiSala, j + 1, i - j - 1);
  //El LowerCase es para linux
  if tmp_rundir = '' then
    dirResultadosCorrida := getDir_Run + LowerCase(nombreArchivo) + barraDir
  else
    dirResultadosCorrida := tmp_rundir;
end;

procedure TSalaDeJuego.Prepararse(TiempoHaciaAdelante: boolean);
var
  acumr:  NReal;
  k, j:   integer;
  cntHidraulicos, cntTermicos: integer;
  fuente: TFuenteAleatoria;
begin
  //Preparar valores de las variables globales de la sala
  acumr := xmatdefs.vsum(globs.DurPos);
  globs.HorasDelPaso := round(acumr);
  if globs.EstadoDeLaSala = CES_OPTIMIZANDO then
    globs.nPasos := globs.calcNPasosOpt
  else
    globs.nPasos := globs.calcNPasosSim;
  globs.fActPaso := 1.0 + globs.TasaDeActualizacion;
  globs.fActPaso := Math.power(1 / globs.fActPaso, globs.HorasDelPaso / (365 * 24));

  //Armar el listado de actores
  j := 0;
  SetLength(actores, listaActores.Count);

  for k := 0 to nods.Count - 1 do
  begin
    actores[j] := TActor(nods[k]);
    Inc(j);
  end;

  for k := 0 to dems.Count - 1 do
  begin
    actores[j] := TActor(dems[k]);
    Inc(j);
  end;

  for k := 0 to arcs.Count - 1 do
  begin
    actores[j] := TActor(arcs[k]);
    Inc(j);
  end;
  cntHidraulicos := 0;
  cntTermicos    := 0;

  for k := 0 to gens.Count - 1 do
  begin
    actores[j] := TActor(gens[k]);
    if actores[j] is TGeneradorHidraulico then
      Inc(cntHidraulicos)
    else if actores[j] is TGTer then
      Inc(cntTermicos);

    Inc(j);
  end;

  for k := 0 to ComercioInternacional.Count - 1 do
  begin
    actores[j] := TActor(ComercioInternacional[k]);
    Inc(j);
  end;

  //Armar el listado de generadores hidrulicos
  setlength(Hidraulicos, cntHidraulicos);
  cntHidraulicos := 0;

  for k := 0 to gens.Count - 1 do
  begin
    if TActor(gens[k]) is TGeneradorHidraulico then
    begin
      hidraulicos[cntHidraulicos] := TGeneradorHidraulico(gens[k]);
      Inc(cntHidraulicos);
    end;
  end;

  //Armar el listado de generadores trmicos
  setlength(termicos, cntTermicos);
  cntTermicos := 0;

  for k := 0 to gens.Count - 1 do
  begin
    if TActor(gens[k]) is TGTer then
    begin
      termicos[cntTermicos] := TGTer(gens[k]);
      Inc(cntTermicos);
    end;
  end;

  //Armar el listado de commbustibles
  setlength(combustibles, listaCombustibles.Count);

  for k := 0 to listaCombustibles.Count - 1 do
    combustibles[k] := TCombustible(listaCombustibles[k]);


  //Armar el listado de fuentes
  ordenarFuentes;
  SetLength(fuentes, listaFuentes.Count);

  // ATENCION aqu controlamos si es necesario esclavizar fuentes.
  for k := 0 to listaFuentes.Count - 1 do
  begin
    fuente := TFuenteAleatoria(listaFuentes[k]);
    if (fuente.durPasoDeSorteoEnHoras = 0) or
      (fuente.durPasoDeSorteoEnHoras = globs.HorasDelPaso) then
      fuentes[k] := fuente
    else
    begin
      if globs.HorasDelPaso < fuente.durPasoDeSorteoEnHoras then
      begin
        listaFuentesReemplazadas.Add(fuente);
        fuentes[k]      := TEsclavizadorSobreMuestreado.Create(
          'SobreMuestreada_' + fuente.nombre, fuente);
        listaFuentes[k] := fuentes[k];
      end
      else
      begin
        listaFuentesReemplazadas.Add(fuente);
        fuentes[k]      := TEsclavizadorSubMuestreado.Create(
          'SubMuestreada_' + fuente.nombre, fuente, fuente.ResumirPromediando);
        listaFuentes[k] := fuentes[k];
      end;
    end;
  end;

  Armar_lst_SorteosDelPaso_Actores;

  globs.ActualizadorLPD.limpiar;

(**** ATENCION *******************************************************
Primero preparan memoria los ACTORES y luego las FUENTES
Esto es as pues los actores pueden registrar funciones en las fuentes
y las fuentes precisan esa informacin para prepararse
*********************************************************************)
  // Que los actores preparen su memoria
  for k := 0 to high(actores) do
    actores[k].PrepararMemoria(globs);

  //Preparar las fuentes
  for k := 0 to high(fuentes) do
  begin
    fuentes[k].prepararMemoria(globs);
    fuentes[k].RegistrarParametrosDinamicos;
  end;

  //Preparar los combustibles
  for k := 0 to high(combustibles) do
  begin
    combustibles[k].RegistrarParametrosDinamicos;
  end;

  self.PubliVars;
  globs.PubliVars;
  // Que los actores publiquen las variables
  for k := 0 to high(actores) do
    actores[k].PubliVars;

  // Que las fuentes publiquen las variables
  for k := 0 to listaFuentesReemplazadas.Count - 1 do
    TCosaConNombre(listaFuentesReemplazadas[k]).PubliVars;
  for k := 0 to high(fuentes) do
    fuentes[k].PubliVars;

  // Que los actores registren sus parmetros dinmicos
  for k := 0 to high(actores) do
    actores[k].RegistrarParametrosDinamicos;

  uCosaConNombre.resolver_referencias(self.listaActores);
  uCosaConNombre.resolver_referencias(self.listaFuentes);
  uCosaConNombre.resolver_referencias(listaFuentesReemplazadas);

  // Preparamos el actualizador de fichas.
  if globs.EstadoDeLaSala = CES_OPTIMIZANDO then
  begin
    globs.ActualizadorLPD.ChequeoFechas(globs.fechaIniOpt, globs.fechaFinOpt);
    globs.ActualizadorLPD.Preparse(TiempoHaciaAdelante, globs.fechaIniOpt,
      globs.fechaFinOpt);
    globs.ActualizadorLPD.PrepararOptSim(globs.fechaIniOpt, globs.fechaFinOpt);
  end
  else
  begin
    globs.ActualizadorLPD.ChequeoFechas(globs.fechaIniSim, globs.fechaFinSim);
    globs.ActualizadorLPD.Preparse(TiempoHaciaAdelante, globs.fechaIniSim,
      globs.fechaFinSim);
    globs.ActualizadorLPD.PrepararOptSim(globs.fechaIniSim, globs.fechaFinSim);
  end;
end;

procedure TSalaDeJuego.PrepararseYPubliVars(lista: TListaDeCosasConNombre);
var
  i: integer;
begin
  for i := 0 to lista.Count - 1 do
  begin
    if TObject(lista[i]) is TActor then
      TActor(lista[i]).PrepararMemoria(globs);
    TCosaConNombre(lista[i]).PubliVars;
  end;
end;

procedure TSalaDeJuego.PrepararseYPubliVars;
var
  i: integer;
  cosasEnLaSala: TListaDeCosasConNombre;
begin
  cosasEnLaSala := TListaDeCosasConNombre.Create('aux_PrepararseYPubliVars');

  cosasEnLaSala.Capacity := 2 + listaActores.Count + listaFuentes.Count;
  cosasEnLaSala.Add(self);
  cosasEnLaSala.Add(globs);
  for i := 0 to listaActores.Count - 1 do
    cosasEnLaSala.Add(TCosaConNombre(listaActores[i]));
  for i := 0 to listaFuentes.Count - 1 do
    cosasEnLaSala.Add(TCosaConNombre(listaFuentes[i]));

  PrepararseYPubliVars(cosasEnLaSala);

  cosasEnLaSala.FreeSinElemenentos;
end;

procedure TSalaDeJuego.Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
var
  k:      integer;
  p1, p2: procedure of object;
  actor1, actor: TActor;
  fuente1, fuente: TFuenteAleatoria;
begin
  // FijarEstadoEstrellita
  if lst_barridoFijarEstadoDeActoresToEstrella <> nil then
    lst_barridoFijarEstadoDeActoresToEstrella.Clear
  else
    lst_barridoFijarEstadoDeActoresToEstrella := TList.Create;

  actor1 := TActor.Create('', TFecha.Create_DT(now()), TFecha.Create_DT(Now()),
    TActor.CreateDefaultLPDUnidades(1));
  p1     := Actor1.PosicionarseEnEstrellita;
  for k := 0 to high(actores) do
  begin
    actor := actores[k];
    p2    := actor.PosicionarseEnEstrellita;
    if @p1 <> @p2 then
      lst_barridoFijarEstadoDeActoresToEstrella.Add(actor);
  end;
  actor1.Free;

  if lst_barridoFijarEstadoDeFuentesToEstrella <> nil then
    lst_barridoFijarEstadoDeFuentesToEstrella.Clear
  else
    lst_barridoFijarEstadoDeFuentesToEstrella := TList.Create;

  fuente1 := TFuenteAleatoria.Create('', -1, False);
  p1      := fuente1.PosicionarseEnEstrellita;
  for k := 0 to listaFuentes.Count - 1 do
  begin
    fuente := fuentes[k];

    if fuente is TEsclavizador then
      p2 := TEsclavizador(fuente).esclava.PosicionarseEnEstrellita
    else
      p2 := fuente.PosicionarseEnEstrellita;

    if @p1 <> @p2 then
      lst_barridoFijarEstadoDeFuentesToEstrella.Add(fuente);
  end;
  fuente1.Free;
end;

procedure TSalaDeJuego.Armar_lst_SorteosDelPaso_Actores;
var
  k, cantRedefiniciones: integer;
  p1, p2: procedure(sortear: boolean) of object;
  actor1, actor: TActor;
begin
  SetLength(lst_SorteosDelPaso_Actores, length(actores));

  actor1 := TActor.Create('', TFecha.Create_DT(now()), TFecha.Create_DT(now()),
    TActor.CreateDefaultLPDUnidades(1));
  p1     := Actor1.SorteosDelPaso;
  cantRedefiniciones := 0;
  for k := 0 to high(actores) do
  begin
    actor := actores[k];
    p2    := actor.SorteosDelPaso;
    if @p1 <> @p2 then
    begin
      lst_SorteosDelPaso_Actores[cantRedefiniciones] := actor;
      cantRedefiniciones := cantRedefiniciones + 1;
    end;
  end;
  actor1.Free;
  if cantRedefiniciones <> Length(lst_SorteosDelPaso_Actores) then
    if cantRedefiniciones <> 0 then
      lst_SorteosDelPaso_Actores :=
        copy(lst_SorteosDelPaso_Actores, 0, cantRedefiniciones)
    else
      lst_SorteosDelPaso_Actores := nil;
end;

procedure TSalaDeJuego.Armar_lst_opt_PrintResultados;
var
  k:      integer;
  p1, p2: procedure(var fsal: textfile) of object;
  actor1: TActor;
begin
  actor1 := TActor.Create('', TFecha.Create_DT(now()), TFecha.Create_DT(now()),
    TActor.CreateDefaultLPDUnidades(1));

  // lst_opt_PrintResultados
  if lst_opt_PrintResultados <> nil then
    lst_opt_PrintResultados.Clear
  else
    lst_opt_PrintResultados := TList.Create;

  p1 := Actor1.opt_PrintResultados;
  for k := 0 to high(actores) do
  begin
    p2 := actores[k].opt_PrintResultados;
    if @p1 <> @p2 then
      lst_opt_PrintResultados.add(actores[k]);
  end;

  actor1.Free;
end;

procedure TSalaDeJuego.Armar_lst_Sim_cronicaIdInicio;
var
  k:      integer;
  p1, p2: function: string of object;
  fuente1, fuente: TFuenteAleatoria;
begin
  // FijarEstadoEstrellita
  if lst_Sim_cronicaIdInicio <> nil then
    lst_Sim_cronicaIdInicio.Clear
  else
    lst_Sim_cronicaIdInicio := TList.Create;

  fuente1 := TFuenteAleatoria.Create('', 0, False);
  p1      := fuente1.cronicaIdInicio;
  for k := 0 to high(fuentes) do
  begin
    fuente := fuentes[k];
    if fuente is TEsclavizador then
      p2 := TEsclavizador(fuente).esclava.cronicaIdInicio
    else
      p2 := fuente.cronicaIdInicio;

    if @p1 <> @p2 then
      lst_Sim_cronicaIdInicio.Add(fuente);
  end;
  fuente1.Free;
end;


procedure TSalaDeJuego.armar_lst_Sim_Paso_Fin;
var
  k:      integer;
  p1, p2: procedure of object;
  actor1: TActor;
begin
  actor1 := TActor.Create('', TFecha.Create_DT(now()), TFecha.Create_DT(now()),
    TActor.CreateDefaultLPDUnidades(1));

  // lst_opt_PrintResultados
  if lst_Sim_Paso_Fin <> nil then
    lst_Sim_Paso_Fin.Clear
  else
    lst_Sim_Paso_Fin := TList.Create;

  p1 := Actor1.Sim_Paso_Fin;
  for k := 0 to high(actores) do
  begin
    p2 := actores[k].Sim_Paso_Fin;
    if @p1 <> @p2 then
      lst_Sim_Paso_Fin.add(actores[k]);
  end;
  actor1.Free;
end;

procedure TSalaDeJuego.Armar_lst_costoDirectoDelPaso;
var
  k:      integer;
  p1, p2: function: NReal of object;
  //  actor1: TActor;
  fuente1: TFuenteAleatoria;
begin
(*  actor1:= TActor.Create('', TFecha.Create_DT(now()), TFecha.Create_DT(now()), TActor.CreateDefaultLPDUnidades);


// lst_opt_PrintResultados
  if lst_actores_costoDirectoDelPaso <> nil then
    lst_actores_costoDirectoDelPaso.Clear
  else
    lst_actores_costoDirectoDelPaso:= TList.Create;
  p1:= Actor1.costoDirectoDelPaso;

  for k:= 0 to high( actores ) do
  begin
    p2:= actores[k].costoDirectoDelpaso;
    if @p1<>@p2 then
      lst_actores_costoDirectoDelPaso.add( actores[k] );
  end;
  actor1.Free;
    *)

  fuente1 := TFuenteAleatoria.Create('', 0, False);
  if lst_fuentes_costoDirectoDelPaso <> nil then
    lst_fuentes_costoDirectoDelPaso.Clear
  else
    lst_fuentes_costoDirectoDelPaso := TList.Create;

  p1 := fuente1.costoDirectoDelPaso;
  for k := 0 to high(fuentes) do
  begin
    if fuentes[k] is TEsclavizador then
      p2 := TEsclavizador(fuentes[k]).esclava.costoDirectoDelPaso
    else
      p2 := fuentes[k].costoDirectoDelPaso;

    if @p1 <> @p2 then
      lst_fuentes_costoDirectoDelPaso.add(fuentes[k]);
  end;
  fuente1.Free;
end;


procedure TSalaDeJuego.Armar_lst_EvolucionarEstado;
var
  k:      integer;
  p1, p2: procedure of object;
  actor1: TActor;
  fuente1: TFuenteAleatoria;
begin
  actor1 := TActor.Create('', TFecha.Create_DT(now()), TFecha.Create_DT(now()),
    TActor.CreateDefaultLPDUnidades(1));

  // lst_opt_PrintResultados
  if lst_actores_EvolucionarEstado <> nil then
    lst_actores_evolucionarEstado.Clear
  else
    lst_actores_evolucionarEstado := TList.Create;

  p1 := Actor1.EvolucionarEstado;

  for k := 0 to high(actores) do
  begin
    p2 := actores[k].EvolucionarEstado;
    if @p1 <> @p2 then
      lst_actores_evolucionarEstado.add(actores[k]);
  end;
  actor1.Free;

  fuente1 := TFuenteAleatoria.Create('', 0, False);
  if lst_fuentes_EvolucionarEstado <> nil then
    lst_fuentes_EvolucionarEstado.Clear
  else
    lst_fuentes_EvolucionarEstado := TList.Create;

  p1 := fuente1.evolucionarEstadoActual;
  for k := 0 to high(fuentes) do
  begin
    p2 := fuentes[k].evolucionarEstadoActual;
    if @p1 <> @p2 then
      lst_fuentes_EvolucionarEstado.add(fuentes[k]);
  end;
  fuente1.Free;
end;

{$IFDEF ITERAR}
procedure TSalaDeJuego.Armar_lst_necesitoIterar;
var
  k:      integer;
  p1, p2: function(kIteracion: integer; var errRelativo: NReal): boolean of object;
  actor1: TActor;
begin
  actor1 := TActor.Create('', TFecha.Create_DT(now()), TFecha.Create_DT(now()),
    TActor.CreateDefaultLPDUnidades(1));

  // lst_opt_PrintResultados
  if lst_necesitoIterar <> nil then
    lst_necesitoIterar.Clear
  else
    lst_necesitoIterar := TList.Create;

  p1 := Actor1.opt_NecesitoIterar;
  for k := 0 to high(actores) do
  begin
    p2 := actores[k].opt_NecesitoIterar;
    if @p1 <> @p2 then
      lst_NecesitoIterar.add(actores[k]);
  end;

  actor1.Free;
end;

{$ENDIF}

(****** por ahora no va esto. Puede ser que vuelva a ponerse para
aumentar la eficiencia

procedure TSalaDeJuego.Armar_lst_Encadenamientos;
var
  iHidraulicos, iAux, nHidraulicos: Integer;
  temp: TGeneradorHidraulico;
function todasResueltas(centralesAguasArriba : TListaCentralesAguasArriba ; var noResuelta : TGeneradorHidraulico) : boolean;
var
  iCentralesEncadenadas, iter: Integer;
  res, buscando: boolean;
begin
  res:= true;
  iCentralesEncadenadas:= 0;
  //Recorro las centrales aguas arriba de la ma, si las encuentro entre las
  //que ya estan ordenadas entonces estan todas resueltas y puedo dejar la central
  //en ese lugar en la lista
  while iCentralesEncadenadas < Length(centralesAguasArriba.lst) do
  begin
    noResuelta:= centralesAguasArriba.lst[iCentralesEncadenadas];
    buscando:= true;
    for iter:= 0 to iHidraulicos -1 do
    begin
      if hidraulicos[iter] = noResuelta then
      begin
        buscando:= false;
        break;
      end;
    end;
    if not buscando then
      inc(iCentralesEncadenadas)
    else
    begin
      res:= false;
      break;
    end;
  end;
  result:= res;
end;

begin
  if length(hidraulicos) = 0 then
  begin
    nHidraulicos:= 0;
    for iAux:= 0 to Gens.lst.Count -1 do
    begin
      if (TGenerador(gens.lst[iAux]) is TGeneradorHidraulico) then
        inc(nHidraulicos);
    end;
    SetLength(hidraulicos, nHidraulicos);
    iHidraulicos:= 0;
    for iAux:= 0 to Gens.lst.Count -1 do
    begin
      if (TGenerador(gens.lst[iAux]) is TGeneradorHidraulico) then
      begin
        hidraulicos[iHidraulicos]:= gens.lst[iAux];
        inc(iHidraulicos);
        if iHidraulicos >= nHidraulicos then
          break;
      end;
    end;
  end
  else
    nHidraulicos:= Length(hidraulicos);

  iHidraulicos:= 0;
  while iHidraulicos < nHidraulicos do
  begin
    if todasResueltas(hidraulicos[iHidraulicos].centralesAguasArriba, temp) then
      inc(iHidraulicos)
    else
    begin
      for iAux:= iHidraulicos +1 to nHidraulicos -1 do
        if hidraulicos[iAux] = temp then
          break;
      hidraulicos[iAux]:= hidraulicos[iHidraulicos];
      hidraulicos[iHidraulicos]:= temp;
    end;
  end;
end;
**********)

{$IFDEF ITERAR}
function TSalaDeJuego.NecesitoIterar: boolean;
var
  k:    integer;
  xerr: NReal;
  cnt:  integer;
begin
  cnt := 0;

  // Atencin: Es a propsito que le preguntamos a todos los actores.
  // No paramos en el primero que precise iterar dado que ya que vamos a iterar
  // le permitimos a los dems mejorar sus valores para lo que hay que llamar
  // a su correspondiente NecesitoIterar.
  for k := 0 to lst_NecesitoIterar.Count - 1 do
    if TActor(lst_NecesitoIterar.Items[k]).opt_NecesitoIterar(
      globs.cntIteracionesDelPaso, xerr) then
      Inc(cnt);

  Result := cnt > 0;
end;

{$ENDIF}

function TSalaDeJuego.getNombreVar(ivar: integer): string;
var
  i:      integer;
  nombre: string;
begin
  nombre := '';
  for i := 0 to high(actores) do
    if actores[i].getNombreVar(ivar, nombre) then
      break;
  if nombre = '' then
    nombre := '??_x' + IntToStr(ivar);
  Result   := nombre;
end;

function TSalaDeJuego.getNombreRes(ires: integer): string;
var
  i:      integer;
  nombre: string;
begin
  nombre := '';
  for i := 0 to high(actores) do
    if actores[i].getNombreRes(ires, nombre) then
      break;
  if nombre = '' then
    nombre := '??_y' + IntToStr(ires);
  Result   := nombre;
end;

procedure TSalaDeJuego.dump_Variables;
var
  archi: string;
begin
  archi := DateTimeToStr(now()) + '_dump_Variables.txt';
  while pos('/', archi) > 0 do
    archi[pos('/', archi)] := '-';
  while pos(':', archi) > 0 do
    archi[pos(':', archi)] := '-';
  archi := getDir_Dbg + archi;
  dump_Variables(archi);
end;

procedure TSalaDeJuego.dump_Variables(archi: string);
const
  indentador = #9;
var
  f: TextFile;
  k: integer;
begin
  if pos(getDir_Dbg, archi) <> 1 then
    archi := getDir_Dbg + archi;
  try
    AssignFile(f, archi);
    rewrite(f);
    writeln(f, 'Estado de la Sala= ', estadoSalaToString(globs.EstadoDeLaSala));
    writeln(f, 'globs.kpaso_= ', globs.kpaso_);
    if globs.EstadoDeLaSala = CES_OPTIMIZANDO then
      writeln(f, 'globs.CF.ordinalEstrellaActual= ', globs.CF.ordinalEstrellaActual);

    writeln(f, 'globs.kcronica= ', globs.kcronica);
{$IFDEF ITERAR}
    writeln(f, 'globs.cntIteracionesDelPaso= ', globs.cntIteracionesDelPaso);
{$ENDIF}
    writeln(f);
    for k := 0 to Nods.Count - 1 do
      TNodo(Nods[k]).dump_Variables(f, indentador);
    for k := 0 to Dems.Count - 1 do
      TDemanda(Dems[k]).dump_Variables(f, indentador);
    for k := 0 to Gens.Count - 1 do
      TGenerador(Gens[k]).dump_Variables(f, indentador);
    for k := 0 to ComercioInternacional.Count - 1 do
      TMercadoSpot(ComercioInternacional[k]).dump_Variables(f, indentador);
    for k := 0 to Arcs.Count - 1 do
      TArco(Arcs[k]).dump_Variables(f, indentador);
    for k := 0 to high(fuentes) do
      fuentes[k].dump_Variables(f, indentador);
  finally
    CloseFile(f);
  end;
end;

procedure TSalaDeJuego.Sim_Cronica_Inicio;
var
  k: integer;
begin
  // 8/11/2011 con esto intentamos que las cronicas sean reproducibles sin importar
  // su largo. O sea que si acortamos el horizonte de simulacicon los tramos iniciales
  // de las crnicas sean los mismos.
  if (RandSeed_SincronizarAlInicioDeCadaCronica) then
    globs.fijarSemillaAleatoria(Self.RandSeedInicial + globs.kCronica);

  globs.Fijar_kPaso(1);
  globs.ActualizadorLPD.PrepararOptSim(globs.fechaIniSim, globs.fechaFinSim);
  for k := 0 to high(actores) do
    actores[k].Sim_Cronica_Inicio;
  for k := 0 to high(fuentes) do
    fuentes[k].Sim_Cronica_Inicio;
  globs.procNot(globs.procNot_InicioCronica);
end;

{procedure TSalaDeJuego.prepararSalaParaPaso;
begin
  globs.ActualizadorLPD.ActualizarFichasHasta( globs.FechaInicioDelpaso );
end;}

procedure TSalaDeJuego.PosicionarseEnEstrellita;
var
  k: integer;
begin
  for k := 0 to high(fuentes) do
    fuentes[k].PosicionarseEnEstrellita;
  for k := 0 to High(fuentesConBCConEstadoEnCF) do
    fuentesConBCConEstadoEnCF[k].calcular_BC;

  for k := 0 to lst_barridoFijarEstadoDeActoresToEstrella.Count - 1 do
    TActor(lst_barridoFijarEstadoDeActoresToEstrella.items[k]).PosicionarseEnEstrellita;
end;

procedure TSalaDeJuego.ActualizarEstadoGlobal;
var
  k: integer;
begin
  for k := 0 to lst_barridoFijarEstadoDeActoresToEstrella.Count - 1 do
    TActor(lst_barridoFijarEstadoDeActoresToEstrella.items[k]).ActualizarEstadoGlobal;
  for k := 0 to lst_barridoFijarEstadoDeFuentesToEstrella.Count - 1 do
    TFuenteAleatoria(lst_barridoFijarEstadoDeFuentesToEstrella[k]).
      ActualizarEstadoGlobal;
end;

procedure TSalaDeJuego.Actores_AcumularAuxs1;
var
  k: integer;
begin
  for k := 0 to high(actores) do
    actores[k].AcumAux1(globs.invNCronicasOpt);
end;

procedure TSalaDeJuego.Actores_SetAuxs1;
var
  k: integer;
begin
  for k := 0 to high(actores) do
    actores[k].SetAux1;
end;

procedure TSalaDeJuego.SorteosDelPasoOpt(sortear: boolean);
var
  k: integer;
begin

// generamos los nmeros aleatorios en las borneras de entrada.
  for k := 0 to high(fuentes) do
    fuentes[k].sorteosDelPaso(sortear);

// para las fuentes que no tienen estado en CF, podemos fijar su estado
// interno (no depende del estado del sistema) y adems ya podemos calcular
// sus Bornes Calculados.
  for k := 0 to high(fuentesConBCSinEstadoEnCF) do
  begin
    fuentesConBCSinEstadoEnCF[k].fijarEstadoInterno;
    fuentesConBCSinEstadoEnCF[k].calcular_BC;
  end;

  for k := 0 to high(lst_SorteosDelPaso_Actores) do
    lst_SorteosDelPaso_Actores[k].SorteosDelPaso(sortear);
end;

procedure TSalaDeJuego.SorteosDelPasoSim(sortear: boolean);
var
  k: integer;
begin
  for k := 0 to high(fuentes) do
  begin
    fuentes[k].sorteosDelPaso(sortear);
    fuentes[k].calcular_BC;
  end;
  for k := 0 to high(lst_SorteosDelPaso_Actores) do
    lst_SorteosDelPaso_Actores[k].SorteosDelPaso(sortear);
end;

procedure TSalaDeJuego.PrepararPaso_as;
var
  k: integer;
begin
  for k := 0 to high(actores) do
  begin
    actores[k].PrepararPaso_as;
  end;
end;

procedure TSalaDeJuego.Fuentes_PrepararPaso_ps;
var
  k: integer;
begin
  for k := 0 to high(Fuentes) do
    Fuentes[k].PrepararPaso_ps;
end;

procedure TSalaDeJuego.Actores_PrepararPaso_ps;
var
  k:   integer;
{$IFDEF CHEQUEOMEM}
  tam: cardinal;
{$ENDIF}
begin
{$IFDEF CHEQUEOMEM}
  tam := udbgutil.tam;
{$ENDIF}
  for k := 0 to high(actores) do
  begin
    actores[k].PrepararPaso_ps;
{$IFDEF CHEQUEOMEM}
    if tam <> udbgutil.tam then
      raise Exception.Create('OJO; el Actor: ' + actores[k].nombre +
        ' pierde memoria en PrepararPaso_ps');
{$ENDIF}
  end;
end;

function TSalaDeJuego.ResolverPaso: NReal;
var
  k: integer;
  ispxres: integer;
begin
  ivar := 1;
  ires := 1;
  ivae := 1;

  // Amar_lst_Encadenamientos;

  // barrido
  for k := 0 to high(actores) do
    actores[k].opt_nvers(ivar, ivae, ires);

{$IFDEF MIPSimplex}
  if ((ires = spx.nf) and (ivar = spx.nc)) and (ivae - 1 = spx.nvents) then
    spx.limpiar
  else
  begin
    spx.Free;
    spx := TMIPSimplex.Create_init(ires, ivar, ivae - 1, self.getNombreVar,
      self.getNombreRes);
  end;
{$ELSE}
  if ((ires = spx.nf) and (ivar = spx.nc)) then
    spx.limpiar
  else
  begin
    spx.Free(True);
    spx := TSimplex.Create_init(ires, ivar, self.getNombreVar, self.getNombreRes);
  end;
{$ENDIF}

  for k := 0 to high(actores) do
    actores[k].opt_cargue(spx);

  // !!!! OJO, los encadenamientos hay que resolverlos antes de
  // fijar las restricciones de caja, pera que los cambios de variables
  // tengan efecto en todas las filas.
  for k := 0 to high(hidraulicos) do
    hidraulicos[k].ResolverEncadenamientos(spx);

  // le damos la oportunidad a las fuentes con estado de cargar
  for k := 0 to high(fuentes) do
    fuentes[k].opt_cargue(spx);

  // fijar las restricciones es lo ltimo que hacemos pues cambia
  // la columna de los trminos independientes
  for k := 0 to high(actores) do
    actores[k].opt_fijarRestriccionesDeCaja(spx);


  try

    ispxres := spx.resolver;

    if ispxres < 0 then
      raise Exception.Create('ERROR DE DATOS, NO ENCONTRE DESPACHO FACTIBLE!!! ispxres:' +
        IntToStr(ispxres) + ' kpaso:' + IntToStr(globs.kPaso_));
  except
    On E: Exception do
    begin
      spx.DumpSistemaToXLT('DESPACHOINFACTIBLE.XLT', e.Message);
      dump_Variables;
      raise;
    end;
  end;

  globs.costodelpaso := -spx.fval;

  // spx.DumpSistemaToXLT('_rch_2' + genStrPasoCronEstrIter + '.xlt', '');

  // spx.DumpSistemaToXLT('spx-despuesderesolver.xlt', 'debug');

  self.costoDirectoDelPaso := 0;
  for k := 0 to high(actores) do
  begin
    actores[k].opt_leerSolucion(spx);
    costoDirectoDelPaso := costoDirectoDelPaso + actores[k].costoDirectoDelPaso;
  end;

  Result := -spx.fval;
end;

procedure TSalaDeJuego.Sim_Paso_Fin;
var
  k: integer;
begin
  for k := 0 to lst_Sim_Paso_Fin.Count - 1 do
    TActor(lst_Sim_Paso_Fin[k]).Sim_Paso_Fin;
  globs.procNot(globs.procNot_FinPaso);
end;

procedure TSalaDeJuego.CapturarResultadosDelPaso;
begin
end;

procedure TSalaDeJuego.Sim_Cronica_Fin;
var
  k: integer;
begin
  for k := 0 to high(actores) do
    actores[k].Sim_Cronica_Fin;
  globs.procNot(globs.procNot_FinCronica);
  Inc(globs.kCronica);
end;

procedure TSalaDeJuego.FinSimulacion;
begin
  globs.procNot(globs.procNot_FinSimulacion);
end;

procedure TSalaDeJuego.FinOptimizacion;
begin
  globs.procNot(globs.procNot_opt_FinOptimizacion);
end;

procedure TSalaDeJuego.optx_nvxs;
var
  oldIvar_xr, oldIvar_xd: integer;
  nFuentesConEstado, nFuentesSinEstado: integer;
  k: integer;
begin
  // ahora determinamos la dimensin del espacio de estado y los frames
  // de variables auxiliares que sea necesario crear.
  ivar_xr     := 0;
  ivar_xd     := 0;
  ivar_auxNReal := 0;
  ivar_auxInt := 0;
  for k := 0 to high(actores) do
    actores[k].optx_nvxs(ivar_xr, ivar_xd, ivar_auxNReal, ivar_auxInt);

  SetLength(fuentesConBCSinEstadoEnCF, length(fuentes));
  SetLength(fuentesConBCConEstadoEnCF, length(fuentes));

  oldIvar_xr := ivar_xr;
  oldIvar_xd := ivar_xd;
  nFuentesConEstado := 0;
  nFuentesSinEstado := 0;
  for k := 0 to high(fuentes) do
  begin
    fuentes[k].optx_nvxs(ivar_xr, ivar_xd, ivar_auxNReal, ivar_auxInt);

    if fuentes[k].dim_BC > 0 then
    begin
      if (oldIvar_xr = ivar_xr) and (oldIvar_xd = ivar_xd) then //No registro estado
      begin
        fuentesConBCSinEstadoEnCF[nFuentesSinEstado] := fuentes[k];
        nFuentesSinEstado := nFuentesSinEstado + 1;
      end
      else
      begin
        fuentesConBCConEstadoEnCF[nFuentesConEstado] := fuentes[k];
        nFuentesConEstado := nFuentesConEstado + 1;
      end;
    end;
    oldIvar_xr := ivar_xr;
    oldIvar_xd := ivar_xd;
  end;
  if nFuentesSinEstado <> 0 then
    fuentesConBCSinEstadoEnCF := copy(fuentesConBCSinEstadoEnCF, 0, nFuentesSinEstado)
  else
    fuentesConBCSinEstadoEnCF := nil;
  if nFuentesConEstado <> 0 then
    fuentesConBCConEstadoEnCF := copy(fuentesConBCConEstadoEnCF, 0, nFuentesConEstado)
  else
    fuentesConBCConEstadoEnCF := nil;
end;

function TSalaDeJuego.ContarVariablesDeEstado: integer;
begin
  optx_nvxs;
  Result := ivar_xr + ivar_xd;
end;

function TSalaDeJuego.generarResumenTermicoPrimerasFichas: string;
var
  archi: TextFile;
  i:     integer;
  res:   string;
begin
  if not DirectoryExists(dirResultadosCorrida) { *Converted from DirectoryExists*  } then
    MkDir(dirResultadosCorrida);
  res := dirResultadosCorrida + 'resumen_termico_' +
    nombreArchSinExtension(archiSala) + '.xlt';
  AssignFile(archi, res);
  try
    Rewrite(archi);
    TGTer.generarLineaEncabezadosResumen(archi);
    for i := 0 to Gens.Count - 1 do
      if Gens[i] is TGTer then
        TGter(Gens[i]).generarLineaResumenPrimerFicha(archi);
    Result := res;
  finally
    CloseFile(archi);
  end;
end;


procedure TSalaDeJuego.EvolucionarEstado;
var
  k: integer;
begin
  for k := 0 to lst_actores_evolucionarEstado.Count - 1 do
    TActor(lst_actores_evolucionarEstado[k]).EvolucionarEstado;
  for k := 0 to lst_fuentes_evolucionarEstado.Count - 1 do
    TFuenteAleatoria(lst_fuentes_evolucionarEstado[k]).EvolucionarEstadoActual;
end;




procedure TSalaDeJuego.Simular;
var
  costoAcum, costoAcumCronica: NReal;
  costosAcum: TDAOfNReal;

  qAct: NReal;
  idCronicaInicioFuenteK: string;
  tmpCF, CFAux: TAdminEstados;

  fsal: TextFile;

{$IFDEF DUMP_TEXT_SIMRES}
  kactorres, kfuenterres: integer;
{$ENDIF}
  CostoAcumVaR95: NReal;
  jCronica: integer;
  CF_AlFinalDeLaCronica: NReal;

begin
  setlength(costosAcum, 0);


  globs.EstadoDeLaSala := CES_SIMULANDO;
  RandSeedInicial      := globs.sorteadorUniforme.RandSeed;

  //Inicializacin de las variables locales al procedimiento
  costoAcum := 0; // costo acumulado actualizado
  //Para sacar los warnings
  CFAux     := nil;
  CFaux_AlInicioDelPaso := 0;

{$IFDEF DUMP_TEXT_SIMRES}
  //Creo el archivo de simres
  if not DirectoryExists(dirResultadosCorrida) { *Converted from DirectoryExists*  } then
    MkDir(dirResultadosCorrida);
  assignfile(fsal, dirResultadosCorrida + 'simres_' + IntToStr(
    RandSeedInicial) + 'x' + IntToStr(Globs.NCronicasSim) + '.xlt');
  rewrite(fsal);
{$ENDIF}

  try
    {$IFDEF MIPSimplex}
    spx := TMipSimplex.Create_init(1, 1, 1, self.getNombreVar, self.getNombreRes);
    // solo para que est definido.
    {$ELSE}
    spx := TSimplex.Create_init(1, 1, self.getNombreVar, self.getNombreRes);
    // solo para que est definido.
    {$ENDIF}

    // Preparamos la sala y los actores.
    Prepararse(True);

    // Determinamos la dimesin del espacio de estados y si es necesario
    // crear frames auxiliares del estado para clculos iterativos.
    optx_nvxs;
    Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
    armar_lst_Sim_Paso_Fin;

    Armar_lst_EvolucionarEstado;
    {$IFDEF ITERAR}
    Armar_lst_necesitoIterar;
    {$ENDIF}

    Armar_lst_Sim_cronicaIdInicio;
    if ArchivoCFAux <> '' then
      CFAux := TAdminEstados.CreateLoadFromArchi(ArchivoCFAux);

    {$IFDEF DUMP_TEXT_SIMRES}
    printEncabezadoSimRes(fsal);
    {$ENDIF}

    globs.procNot(globs.procNot_InicioSimulacion);


    globs.kCronica := 1;
    setlength(costosAcum, globs.NCronicasSim);

    while (globs.kCronica <= globs.NCronicasSim) and (not globs.abortarSim) do
    begin
      Sim_Cronica_Inicio;
      // inicializamos acumulador de costos de la crnica
      costoAcumCronica := 0;
      qAct := 1;

      {$IFDEF DUMP_TEXT_SIMRES}
      writeln(fsal);
      Write(fsal, 'CRONICA:', #9, globs.kCronica, #9, 'SemillaAleatoria:', #9,
        globs.sorteadorUniforme.RandSeed);
      for kfuenterres := 0 to lst_Sim_cronicaIdInicio.Count - 1 do
      begin
        idCronicaInicioFuenteK :=
          TFuenteAleatoria(lst_Sim_cronicaIdInicio[kfuenterres]).cronicaIdInicio;
        if idCronicaInicioFuenteK <> '' then
          Write(fsal, #9, idCronicaInicioFuenteK);
      end;
      writeln(fsal);

      // PRINT kencab= 0
      Write(fsal, '-', #9, '-');
      for kactorres := 0 to high(actores) do
        actores[kactorres].sim_PrintResultados_Encab(fsal, 0);
      for kfuenterres := 0 to high(fuentes) do
        fuentes[kfuenterres].sim_PrintResultados_Encab(fsal, 0);
      Write(fsal, #9, '-');
      if CFaux <> nil then
        Write(fsal, #9, '-');
      Write(fsal, #9, '-');
      writeln(fsal, #9, '-');

      // PRINT kencab= 1
      Write(fsal, '-', #9, '-');
      for kactorres := 0 to high(actores) do
        actores[kactorres].sim_PrintResultados_Encab(fsal, 1);
      for kfuenterres := 0 to high(fuentes) do
        fuentes[kfuenterres].sim_PrintResultados_Encab(fsal, 1);
      Write(fsal, #9, '[USD]');
      Write(fsal, #9, '[USD]');
      if CFaux <> nil then
        Write(fsal, #9, '[USD]');
      Write(fsal, #9, '[USD]');
      writeln(fsal, #9, '[u]');

      // PRINT kencab= 2
      Write(fsal, '-', #9, '-');
      for kactorres := 0 to high(actores) do
        actores[kactorres].sim_PrintResultados_Encab(fsal, 2);
      for kfuenterres := 0 to high(fuentes) do
        fuentes[kfuenterres].sim_PrintResultados_Encab(fsal, 2);
      Write(fsal, #9, 'CF_AlInicioDelPaso');
      if CFaux <> nil then
        Write(fsal, #9, 'CFaux');
      Write(fsal, #9, 'CPDirecto');
      Write(fsal, #9, 'CPSimplex');
      writeln(fsal, #9, 'cntIterPaso');

      // PRINT kencab= 3
      Write(fsal, 'Paso', #9, 'FechaInicioDelPaso');
      for kactorres := 0 to high(actores) do
        actores[kactorres].sim_PrintResultados_Encab(fsal, 3);
      for kfuenterres := 0 to high(fuentes) do
        fuentes[kfuenterres].sim_PrintResultados_Encab(fsal, 3);
      Write(fsal, #9, '0');
      if CFaux <> nil then
        Write(fsal, #9, '0');
      Write(fsal, #9, '0');
      Write(fsal, #9, '0');
      writeln(fsal, #9, '0');
      {$ENDIF}


      while (globs.kPaso_ <= globs.nPasos) and (not globs.abortarSim) do
      begin
        globs.procNot(globs.procNot_InicioPaso);

        //prepararSalaParaPaso;
        globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);

        PrepararPaso_as;
        SorteosDelPasoSim(True);


        if globs.CF <> nil then
        begin
          ActualizarEstadoGlobal;
          CF_AlInicioDelPaso := globs.CF.costoContinuo(globs.kPaso_);
        end
        else
          CF_AlInicioDelPaso := 0;

        if CFaux <> nil then
        begin
          tmpCF    := globs.CF;
          globs.CF := CFaux;
          globs.CFAuxActivo := True;
          ActualizarEstadoGlobal;
          globs.CFAuxActivo := False;
          globs.CF := tmpCF;
          CFaux_AlInicioDelPaso := CFaux.costoContinuo(globs.kPaso_);
        end;

        Fuentes_PrepararPaso_ps;


{$IFDEF ITERAR}
        globs.cntIteracionesDelPaso := 0;
        repeat
          Inc(globs.cntIteracionesDelPaso);


          Actores_PrepararPaso_ps;


          CostoDelPaso := ResolverPaso;
        until (globs.cntIteracionesDelPaso >= globs.NMAX_ITERACIONESDELPASO_SIM) or
          (not NecesitoIterar);
{$ELSE}
        Actores_PrepararPaso_ps;
        costoDelPaso := ResolverPaso;
{$ENDIF}
        Sim_Paso_Fin;

        {$IFDEF DUMP_TEXT_SIMRES}
        Write(fsal, IntToStr(globs.kPaso_), #9, globs.FechaInicioDelPaso.AsISOStr);
        for kactorres := 0 to high(actores) do
          actores[kactorres].sim_PrintResultados(fsal);
        for kfuenterres := 0 to high(fuentes) do
          fuentes[kfuenterres].sim_PrintResultados(fsal);

        Write(fsal, #9, FloatToStrF(CF_AlInicioDelPaso, formatoReales, 12, 1));
        if CFAux <> nil then
          Write(fsal, #9, FloatToStrF(CFAux_AlInicioDelPaso, formatoReales, 12, 1));

        Write(fsal, #9, FloatToStrF(costoDirectoDelPaso, formatoReales, 12, 1));
        Write(fsal, #9, FloatToStrF(costoDelPaso, formatoReales, 12, 1));
{$IFDEF ITERAR}
        writeln(fsal, #9, globs.cntIteracionesDelPaso);
{$ELSE}
        writeln(fsal, #9, -1);
{$ENDIF}

        {$ENDIF}

        EvolucionarEstado;

        globs.Fijar_kPaso(globs.kPaso_ + 1);
        costoAcumCronica := costoAcumCronica + costoDirectoDelPaso * qAct;
        qAct := qAct * globs.fActPaso;
      end;

      (*** ahora guardo el resultado de la crnica y le sumo el CF_AlFinal de la misma **)
      if globs.CF <> nil then
      begin
        ActualizarEstadoGlobal;
        CF_AlFinalDeLaCronica := globs.CF.costoContinuo(globs.kPaso_);
      end
      else
        CF_AlFinalDeLaCronica := 0;

      costoAcumCronica := costoAcumCronica + qAct * CF_AlFinalDeLaCronica;
      costosAcum[globs.kcronica - 1] := costoAcumCronica;
      costoAcum := costoAcum + costoAcumCronica / globs.NCronicasSim;
      Sim_Cronica_Fin; // entre otras cosas incrementa globs.kCronica
    end;
    FinSimulacion;
    globs.EstadoDeLaSala := CES_SIMULACION_TERMINADA;
  finally

    {$IFDEF DUMP_TEXT_SIMRES}
    printFinalSimRes(fsal);
    Close(fsal);
    {$ENDIF}

    assignfile(fsal, dirResultadosCorrida + 'simcosto_' + IntToStr(
      RandSeedInicial) + 'x' + IntToStr(Globs.NCronicasSim) + '.xlt');
    rewrite(fsal);

    if length(CostosAcum) > 0 then
    begin
      system.writeln(fsal, CostoAcum / 1.0E6, #9, '[MUSD]', #9,
        'Costo esperado de operacin actualizado.');
      system.writeln(fsal, globs.TasaDeActualizacion, #9, '[p.u.]',
        #9, 'Tasa de descuento anual.');
      QuickSort_Creciente(CostosAcum);
      CostoAcumVaR95 := Interpolar(CostosAcum, 0, 1, 0.95);
      system.writeln(fsal, CostoAcumVaR95 / 1E6, #9, '[MUSD]', #9,
        'Costo con riesgo 5% de ser excedido.');
      system.Write(fsal, 'costos por crncia: ');
      for jCronica := 0 to high(costosAcum) do
        system.Write(fsal, #9, costosAcum[jCronica] / 1E6: 12: 3);
      system.writeln(fsal);
      Close(fsal);
      setlength(costosAcum, 0);
    end;

    if globs.EstadoDeLaSala <> CES_SIMULACION_TERMINADA then
      globs.EstadoDeLaSala := CES_SIMULACION_ABORTADA;

    if CFAux <> nil then
      CFAux.Free;
  end;
end;



procedure TSalaDeJuego.ImprimirPotenciasFirmes;

  procedure PrintEncabezado(var fPotsFirmes: TextFile);
  var
    iposteres, kactor: integer;
  begin
    system.Writeln(fPotsFirmes, 'Versin del simulador:'#9, vSimSEESimulador);
    system.writeln(fPotsFirmes, 'Inicio simulacin: '#9, DateTimeToIsoStr(now()));
    system.Writeln(fPotsFirmes, 'FechaIniSim: '#9, globs.fechaIniSim.AsISOStr,
      #9, 'FechaFinSim: ', #9, globs.fechaFinSim.AsISOStr);
    system.writeln(fPotsFirmes, 'NCronicas:'#9, 1);
    system.writeln(fPotsFirmes, 'NPasos:'#9, globs.nPasos);
    system.writeln(fPotsFirmes, 'NPostes:'#9, length(globs.Durpos));
    system.Write(fPotsFirmes, 'DurPos[h]:');
    for iposteres := 0 to high(globs.DurPos) do
      Write(fPotsFirmes, #9, globs.DurPos[iposteres]: 6: 0);
    system.writeln(fPotsFirmes);
    system.writeln(fPotsFirmes, 'NActores:'#9, length(actores));
    TActor.printEncabezadosResumenSim(fPotsFirmes);
    for kactor := 0 to high(actores) do
      actores[kactor].printResumenSim(fPotsFirmes);

    writeln(fPotsFirmes);
    writeln(fPotsFirmes, 'CRONICA:'#9, globs.kCronica, #9, 'SemillaAleatoria:'#9,
      globs.sorteadorUniforme.RandSeed);

    // PRINT kencab= 0
    Write(fPotsFirmes, '-'#9'-');
    for kactor := 0 to high(termicos) do
      termicos[kactor].sim_PrintResultados_Encab_PotFirme(fPotsFirmes, 0);
    writeln(fPotsFirmes);

    // PRINT kencab= 1
    Write(fPotsFirmes, '-'#9'-');
    for kactor := 0 to high(termicos) do
      termicos[kactor].sim_PrintResultados_Encab_PotFirme(fPotsFirmes, 1);
    writeln(fPotsFirmes);

    // PRINT kencab= 2
    Write(fPotsFirmes, 'Paso'#9'FechaInicioDelPaso');
    for kactor := 0 to high(termicos) do
      termicos[kactor].sim_PrintResultados_Encab_PotFirme(fPotsFirmes, 2);
    writeln(fPotsFirmes);
  end;

var
  ipaso, kactor: integer;
  fPotsFirmes_porpaso: TextFile;
  fPotsFirmes_Mensuales: TextFile;
  potFirme: array of TDAOfNReal;
  mes, anio: array of word;
  iActor: integer;
  //  I: Integer;
  cnt, jpaso: integer;
  a: NReal;

begin

  globs.EstadoDeLaSala := CES_SIMULANDO;
  try
    // Preparamos la sala y los actores.
    globs.kCronica := 1;
    Prepararse(True);
    Sim_Cronica_Inicio;

    setLength(potFirme, length(termicos));
    for iActor := 0 to high(termicos) do
      setLength(potFirme[iActor], globs.NPasos);
    setLength(mes, globs.npasos);
    setlength(anio, globs.NPasos);

    //Creo el archivo de simres
    if not DirectoryExists(dirResultadosCorrida)
    { *Converted from DirectoryExists*  } then
      MkDir(dirResultadosCorrida);

    assignfile(fPotsFirmes_porpaso, dirResultadosCorrida +
      'potencias_Termicas_Firmes_porpaso.xlt');
    rewrite(fPotsFirmes_porpaso);
    PrintEncabezado(fPotsFirmes_porpaso);

    assignfile(fPotsFirmes_mensuales, dirResultadosCorrida +
      'potencias_Termicas_Firmes_mensuales.xlt');
    rewrite(fPotsFirmes_mensuales);
    PrintEncabezado(fPotsFirmes_mensuales);

    while (globs.kPaso_ <= globs.nPasos) do
    begin
      globs.procNot(globs.procNot_InicioPaso);
      globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);
      mes[globs.kPaso_ - 1]  := globs.MesInicioDelPaso;
      anio[globs.kPaso_ - 1] := globs.AnioInicioDelPaso;
      Write(fPotsFirmes_porpaso, IntToStr(globs.kPaso_), #9,
        globs.FechaInicioDelPaso.AsISOStr);
      for kactor := 0 to high(termicos) do
      begin
        potFirme[kActor][globs.kPaso_ - 1] := termicos[kactor].PotenciaFirme;
        termicos[kactor].sim_PrintResultados_PotFirme(fPotsFirmes_porpaso);
      end;
      writeln(fPotsFirmes_porpaso);
      globs.Fijar_kPaso(globs.kPaso_ + 1);
    end;
    globs.EstadoDeLaSala := CES_SIMULACION_TERMINADA;


    ipaso := 0;
    jpaso := 1;
    while ipaso < globs.npasos do
    begin
      Write(fPotsFirmes_mensuales, anio[ipaso], #9, mes[ipaso]);

      for kactor := 0 to high(termicos) do
      begin
        jpaso := ipaso + 1;
        a     := potFirme[kactor][ipaso];
        cnt   := 1;
        while (jpaso < globs.npasos) and (mes[jpaso] = mes[ipaso]) do
        begin
          Inc(cnt);
          a := a + potFirme[kactor][jpaso];
          Inc(jpaso);
        end;
        a := a / cnt;
        Write(fPotsFirmes_mensuales, #9, a);
      end;
      ipaso := jpaso;
      writeln(fPotsFirmes_mensuales);
    end;

  finally
    system.writeln(fPotsFirmes_porpaso, 'Fin simulacin: ', #9, DateTimeToStr(now()));
    closefile(fPotsFirmes_porpaso);
    closefile(fpotsFirmes_mensuales);
  end;
end;

procedure TSalaDeJuego.ordenarFuentes;
var
  auxSwap, fuenteI: TFuenteAleatoria;
  huboReferencia: boolean;
  i, j: integer;
begin
  i := 0;
  //El -1 esta bien porque la ultima fuente no tiene despues de ella nadie,
  //particularmente nadie que la referencie
  while i < listaFuentes.Count - 1 do
  begin
    fuenteI := TFuenteAleatoria(listaFuentes[i]);
    huboReferencia := False;
    for j := i + 1 to listaFuentes.Count - 1 do
    begin
      if fuenteI.referenciaFuente(TFuenteAleatoria(listaFuentes[j])) then
      begin
        assert(not TFuenteAleatoria(listaFuentes[j]).referenciaFuente(fuenteI),
          'TSalaDeJuego.ordenarFuentes: hay un ciclo entre las fuentes.' +
          'Las fuentes ' + fuenteI.nombre + ' y ' +
          TFuenteAleatoria(listaFuentes[j]).nombre + ' se referencian mutuamente.');
        auxSwap := TFuenteAleatoria(listaFuentes[j]);
        listaFuentes[j] := fuenteI;
        listaFuentes[i] := auxSwap;
        huboReferencia := True;
        break;
      end;
    end;
    if not huboReferencia then
      Inc(i);
  end;
end;


function TSalaDeJuego.CostoDelPaso_masCF_llegada: NReal;
var
  costoDirectoDelPaso_Actores, costoDirectoDelPaso_Fuentes: NReal;
  CF_llegada: NReal;
  k: integer;
begin
  costoDirectoDelPaso_Actores := 0;
  for k := 0 to high(Actores) do
    costoDirectoDelPaso_Actores :=
      costoDirectoDelPaso_Actores + Actores[k].costoDirectoDelPaso;

  // no me imagino fuentes con costo pero por las dudas ponemos
  costoDirectoDelPaso_Fuentes := 0;
  for k := 0 to lst_fuentes_costoDirectoDelPaso.Count - 1 do
    costoDirectoDelPaso_Fuentes :=
      costoDirectoDelPaso_Fuentes + TFuenteAleatoria(lst_fuentes_costoDirectoDelPaso[k]).costoDirectoDelPaso;

  ActualizarEstadoGlobal; // posicionamos la estrella de acuerdo al estado de los actores
  CF_llegada := globs.CF.costoContinuo(globs.kPaso_ + 1);

  Result := costoDirectoDelPaso_Actores + costoDirectoDelPaso_Fuentes +
    globs.factPaso * CF_llegada;
end;

procedure TSalaDeJuego.inicializarOptimizacion(const costoFuturo: TMatOfNReal);
var
  k: integer;
begin
  if not DirectoryExists(dirResultadosCorrida) { *Converted from DirectoryExists*  } then
    MkDir(dirResultadosCorrida);
  globs.invNCronicasOpt := 1 / globs.NCronicasOpt;
  globs.EstadoDeLaSala := CES_OPTIMIZANDO;
{$IFDEF MIPSimplex}
  spx := TMIPSimplex.Create_init(1, 1, 1, self.getNombreVar, self.getNombreRes);
  // solo para que est definido.
{$ELSE}
  spx := TSimplex.Create_init(1, 1, self.getNombreVar, self.getNombreRes);
  // solo para que est definido.
{$ENDIF}
  Prepararse(False);
  optx_nvxs;
  if (ivar_xr = 0) and (ivar_xd = 0) then
  begin
    globs.EstadoDeLaSala := CES_OPTIMIZACION_TERMINADA;
    exit; // si no hay variables de estado no optimizo nada y me voy
  end;

  Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
  Armar_lst_costoDirectoDelPaso;

  if globs.CF <> nil then
    globs.CF.Free;
  globs.CF := TAdminEstados.Create(ivar_xr, ivar_xd, globs.NPasos);
  //    globs.ActualizadorLPD.ActualizarFichasHasta( globs.fechaFin  );

  for k := 0 to high(actores) do
    actores[k].optx_RegistrarVariablesDeEstado(globs.CF);
  for k := 0 to high(fuentes) do
    fuentes[k].optx_RegistrarVariablesDeEstado(globs.CF);
  globs.CF.CrearElEspacioTiempo(globs.fechaIniOpt, globs.fechaFinOpt,
    globs.HorasDelPaso, costoFuturo);

  // Ahora creamos frames para las variables auxiliares
  setlength(globs.Auxs_r0, ivar_auxNReal);
  setlength(globs.Auxs_r1, ivar_auxNReal);
  for k := 0 to ivar_auxNReal - 1 do
  begin
    setlength(globs.Auxs_r0[k], globs.CF.constelacion.nEstrellas);
    setlength(globs.Auxs_r1[k], globs.CF.constelacion.nEstrellas);
    vclear(globs.Auxs_r0[k]);
    vclear(globs.Auxs_r1[k]);
  end;
  setlength(globs.Auxs_i0, ivar_auxInt);
  setlength(globs.Auxs_i1, ivar_auxInt);
  for k := 0 to ivar_auxInt - 1 do
  begin
    setlength(globs.Auxs_i0[k], globs.CF.constelacion.nEstrellas);
    setlength(globs.Auxs_i1[k], globs.CF.constelacion.nEstrellas);
    vclear(globs.Auxs_i0[k]);
    vclear(globs.Auxs_i1[k]);
  end;

  // fijamos la fecha del paso igual a la de inicio del ltimo paso
  globs.Fijar_kPaso(globs.nPasos);
  //prepararSalaParaPaso;
  globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);

  //globs.ActualizadorLPD.DumpListaToArchi('fichaslpd.txt');
  Armar_lst_EvolucionarEstado;
{$IFDEF ITERAR}
  Armar_lst_necesitoIterar;
{$ENDIF}

{$IFDEF PERTURBADO}
  //-- introducimos una perturbacin manualmente --
  globs.CF.Free;
  globs.CF := TAdminEstados.CreateLoadFromArchi(dirResultadosCorrida + 'CF.bin');
  vswap(globs.CF.constelacion.fcosto[1], globs.CF.constelacion.fcosto[globs.kPaso_]);

  globs.CF.setEstrellaCERO;
  globs.CF.estrella_kr[0] := 5;
  //    globs.CF.SetCostoEstrella(  globs.kPaso_, 1E8 );
{$ELSE}
  if usarArchivoParaInicializarFrameInicial then
    globs.CF.InicializarFrameFinal(archivoCF_ParaEnganches,
      // globs.fechaFinOpt,
      enganchesContinuos, enganchesDiscretos)
  else
    globs.CF.constelacion.ClearFrame(globs.kPaso_ + 1);
{$ENDIF}

{$IFDEF ESTABILIZAR_FRAMEINICIAL}
  if (costoFuturo <> nil) and EstabilizarInicio then
    EstabilizarFrameInicial;
{$ENDIF}
  RandSeedInicial := globs.sorteadorUniforme.RandSeed;
end;

procedure TSalaDeJuego.calcularRangoEstrellas(estrellaIni, estrellaFin: integer);
var
  kcron, kestr: integer;
  CostoFuturo_Cronica, CostoFuturo_Esperado: NReal;
begin
  //prepararSalaParaPaso;
  globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);
  PrepararPaso_as;
  //globs.procNot(globs.procNot_opt_InicioCalculosDeEtapa);

  if globs.SortearOpt then // Clculo de los costos de la etapa con sorteos
  begin
  (* optimizacin CRONIZADA
    Para cada crnica realizamos sorteos y realizamos un barrido de los
    estados con el sorteo fijo. As vamos acumulando los costos del paso
    con cada sorteo para cada uno de los estados. Despus de haber realizado
    todos los sorteos-barridos_de_estado que queremos, realizamos un nuevo
    barrido_de_estado para promediar los valores acumulados.
    El orden en que se realiza esto es importante, pues es importante calcular con
    cada sorteo el costo para los diferentes estados. Los sorteos determinan
    las mquinas que estan disponibles, los aportes a los embalses y los
    recursos disponibles en general. Es importante que para un mismo conjunto
    de recursos disponibles se realice el barrido de los estados y luego con
    otro conjunto para salvaguardar la monotona esperable de los costos de
    una etapa respecto de las variables de estado.
    *)
    // borro el frame pues lo voy a usar para acumular
    globs.CF.constelacion.ClearFrame(globs.kPaso_, estrellaIni, estrellaFin);
    globs.ClearAuxs1;
    for kCron := 1 to globs.NCronicasOpt do
    begin
      globs.kCronica := kCron;
      //      globs.procNot( globs.procNot_opt_InicioCronicaSorteos );
      SorteosDelPasoOpt(True);
      // Aqui hacemos el barrido de los estados
      // nos posicionamos en la primer estrella
      globs.CF.posicionarseEnEstrella(estrellaIni);
      for kestr := estrellaIni to estrellaFin do
      begin
        globs.CF.SetEstadoToEstrella; // Fijamos la estrella
        PosicionarseEnEstrellita;     // Fijamos el estado en los actores
        Fuentes_PrepararPaso_ps;
{$IFDEF ITERAR}
        globs.cntIteracionesDelPaso := 0;
        repeat
          Inc(globs.cntIteracionesDelPaso);
{$ENDIF}
          Actores_PrepararPaso_ps;
          ResolverPaso;
{$IFDEF ITERAR}
        until (globs.cntIteracionesDelPaso >= globs.NMAX_ITERACIONESDELPASO_OPT) or
          (not NecesitoIterar);
{$ENDIF}
        EvolucionarEstado;
        CostoFuturo_cronica := CostoDelPaso_masCF_llegada;
        globs.CF.AcumCostoEstrella(globs.kPaso_, CostoFuturo_Cronica *
          globs.invNCronicasOpt);
        Actores_AcumularAuxs1;
{$IFDEF MIPSimplex}
{$IFDEF SPXMEJORCAMINO}
        vswap(spx.mejorCaminoEsperado, spx.mejorCaminoEncontrado);
{$ENDIF}
{$ENDIF}
        globs.CF.incEstrella; // pasamos a la siguiente estrella
      end; // for de las estrellas
    end; // for de las crnicas
  end // optimizacin Cronizada
  else
  begin // optimizacin con valores esperados
    globs.kCronica := 0; // ponemos a cero para que sea en valor esperado

    SorteosDelPasoOpt(False);
    // Aqui hacemos el barrido de los estados
    // nos posicionamos en la primer estrella
    globs.CF.posicionarseEnEstrella(estrellaIni);
    for kEstr := estrellaIni to estrellaFin do
    begin
      // fijamos el estado
      globs.CF.SetEstadoToEstrella;
      PosicionarseEnEstrellita;// Fijamos el estado en los actores

      Fuentes_PrepararPaso_ps;
{$IFDEF ITERAR}
      globs.cntIteracionesDelPaso := 0;
      repeat
        Inc(globs.cntIteracionesDelPaso);
{$ENDIF}
        Actores_PrepararPaso_ps;
        ResolverPaso;
{$IFDEF ITERAR}
      until (globs.cntIteracionesDelPaso >= globs.NMAX_ITERACIONESDELPASO_OPT) or
        (not NecesitoIterar);
{$ENDIF}
      EvolucionarEstado;

      CostoFuturo_Esperado := CostoDelPaso_masCF_llegada;
      globs.CF.SetCostoEstrella(globs.kPaso_, CostoFuturo_Esperado);
      Actores_SetAuxs1;
{$IFDEF MIPSimplex}
{$IFDEF SPXMEJORCAMINO}
      vswap(spx.mejorCaminoEsperado, spx.mejorCaminoEncontrado);
{$ENDIF}
{$ENDIF}
      globs.CF.incEstrella;
    end;// barrido estrellas
  end;
end;

function TSalaDeJuego.genStrPasoCronEstrIter: string;//Optimizacion
begin
  if globs.CF <> nil then
  begin
  {$IFDEF ITERAR}
    Result := 'kpaso' + IntToStr(globs.kPaso_) + '_kCronica' +
      IntToStr(globs.kCronica) + '_kEstr' + IntToStr(globs.CF.ordinalEstrellaActual) +
      'kIter' + IntToStr(globs.cntIteracionesDelPaso);
  {$ELSE}
    Result := 'kpaso' + IntToStr(globs.kPaso_) + '_kCronica' +
      IntToStr(globs.kCronica) + '_kEstr' + IntToStr(globs.CF.ordinalEstrellaActual);
  {$ENDIF}
  end
  else
  begin
  {$IFDEF ITERAR}
    Result := 'kpaso' + IntToStr(globs.kPaso_) + '_kCronica' +
      IntToStr(globs.kCronica) + 'kIter' + IntToStr(globs.cntIteracionesDelPaso);
  {$ELSE}
    Result := 'kpaso' + IntToStr(globs.kPaso_) + '_kCronica' + IntToStr(globs.kCronica);
  {$ENDIF}
  end;
end;

function TSalaDeJuego.genStrCronPasoIter: string;//Simulacion
begin
{$IFDEF ITERAR}
  Result := 'kCronica' + IntToStr(globs.kCronica) + '_kpaso' +
    IntToStr(globs.kPaso_) + 'kIter' + IntToStr(globs.cntIteracionesDelPaso);
{$ELSE}
  Result := 'kCronica' + IntToStr(globs.kCronica) + '_kpaso' + IntToStr(globs.kPaso_);
{$ENDIF}
end;



procedure TSalaDeJuego.Optimizar;
var
  k, kCron: integer;
  CostoFuturo_Cronica, CostoFuturo_Esperado: NReal;
  NoFinBarridoEstrellas: boolean;
{$IFDEF DUMP_TEXT_OPTRES}
var
  fsal:     TextFile;
  fsalopen: boolean;
  fsal_opt: TDAOfTextFile;
{$ENDIF}
begin
  if not DirectoryExists(dirResultadosCorrida) { *Converted from DirectoryExists*  } then
    MkDir(dirResultadosCorrida);

  RandSeedInicial := globs.sorteadorUniforme.RandSeed;
  globs.invNCronicasOpt := 1 / globs.NCronicasOpt;
  try
    globs.EstadoDeLaSala := CES_OPTIMIZANDO;
{$IFDEF DUMP_TEXT_OPTRES}
    fsalopen := False;
{$ENDIF}

    try
{$IFDEF MIPSimplex}
      spx := TMIPSimplex.Create_init(1, 1, 1, self.getNombreVar, self.getNombreRes);
      // solo para que est definido.
{$ELSE}
      spx := TSimplex.Create_init(1, 1, self.getNombreVar, self.getNombreRes);
      // solo para que est definido.
{$ENDIF}
      Prepararse(False);

      optx_nvxs;

      if (ivar_xr = 0) and (ivar_xd = 0) then
      begin
        globs.EstadoDeLaSala := CES_OPTIMIZACION_TERMINADA;
        exit; // si no hay variables de estado no optimizo nada y me voy
      end;

      Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
      Armar_lst_costoDirectoDelPaso;

      if globs.CF <> nil then
        globs.CF.Free;
      globs.CF := TAdminEstados.Create(ivar_xr, ivar_xd, globs.NPasos);
      //    globs.ActualizadorLPD.ActualizarFichasHasta( globs.fechaFin  );

      for k := 0 to high(actores) do
        actores[k].optx_RegistrarVariablesDeEstado(globs.CF);
      for k := 0 to high(fuentes) do
        fuentes[k].optx_RegistrarVariablesDeEstado(globs.CF);

      globs.CF.CrearElEspacioTiempo(globs.fechaIniOpt, globs.fechaFinOpt,
        globs.HorasDelPaso, nil);

      // Ahora creamos frames para las variables auxiliares
      setlength(globs.Auxs_r0, ivar_auxNReal);
      setlength(globs.Auxs_r1, ivar_auxNReal);
      for k := 0 to ivar_auxNReal - 1 do
      begin
        setlength(globs.Auxs_r0[k], globs.CF.constelacion.nEstrellas);
        setlength(globs.Auxs_r1[k], globs.CF.constelacion.nEstrellas);
        vclear(globs.Auxs_r0[k]);
        vclear(globs.Auxs_r1[k]);
      end;
      setlength(globs.Auxs_i0, ivar_auxInt);
      setlength(globs.Auxs_i1, ivar_auxInt);
      for k := 0 to ivar_auxInt - 1 do
      begin
        setlength(globs.Auxs_i0[k], globs.CF.constelacion.nEstrellas);
        setlength(globs.Auxs_i1[k], globs.CF.constelacion.nEstrellas);
        vclear(globs.Auxs_i0[k]);
        vclear(globs.Auxs_i1[k]);
      end;

      // fijamos la fecha del paso igual a la de inicio del ltimo paso
      globs.Fijar_kPaso(globs.nPasos);
      //prepararSalaParaPaso;
      globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);
      //globs.ActualizadorLPD.DumpListaToArchi('fichaslpd.txt');

      Armar_lst_EvolucionarEstado;
{$IFDEF ITERAR}
      Armar_lst_necesitoIterar;
{$ENDIF}
{$IFDEF PERTURBADO}
      // Frame CERO EN CERO y un pendorcho
      globs.CF.constelacion.ClearFrame(globs.kPaso_ + 1);
      globs.CF.posicionarseEnEstrella(2);
      //    globs.CF.setEstrellaCERO;
      //    globs.CF.estrella_kr[0]:= 2;
      globs.CF.SetCostoEstrella(globs.kPaso_ + 1, 1e7);
{$ELSE}
      if usarArchivoParaInicializarFrameInicial then
        globs.CF.InicializarFrameFinal(
          archivoCF_ParaEnganches,
          //        globs.fechaFinOpt,
          enganchesContinuos,
          enganchesDiscretos)
      else
        globs.CF.constelacion.ClearFrame(globs.kPaso_ + 1);
{$ENDIF}

{$IFDEF ESTABILIZAR_FRAMEINICIAL}
      if EstabilizarInicio then
        EstabilizarFrameInicial;
{$ENDIF}
{$IFDEF DUMP_TEXT_OPTRES}
      inicializarArchisOptRes(fsal, fsal_opt, fsalopen);
{$ENDIF}
      if not DirectoryExists(dirResultadosCorrida)
      { *Converted from DirectoryExists*  } then
        MkDir(dirResultadosCorrida);
      //Hasta aca viene el inicializarOptimizacion

      globs.procNot(globs.procNot_opt_InicioOptimizacion);

      // Barrido de los pasos en reversa
      while (globs.kPaso_ > 0) and (not globs.abortarSim) do
      begin
{$IFDEF DUMP_TEXT_OPTRES}
        Write(fsal, IntToStr(globs.kPaso_) + #9 + globs.FechaInicioDelpaso.AsISOStr);
        for k := 0 to high(fsal_opt) do
          Write(fsal_opt[k], IntToStr(globs.kPaso_) + #9 + globs.FechaInicioDelpaso.AsISOStr);
{$ENDIF}
        //prepararSalaParaPaso;
        globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);

        PrepararPaso_as;

        globs.procNot(globs.procNot_opt_InicioCalculosDeEtapa);

        if globs.SortearOpt then // Clculo de los costos de la etapa con sorteos
        begin
      (* optimizacin CRONIZADA
        Para cada crnica realizamos sorteos y realizamos un barrido de los
        estados con el sorteo fijo. As vamos acumulando los costos del paso
        con cada sorteo para cada uno de los estados. Despus de haber realizado
        todos los sorteos-barridos_de_estado que queremos, realizamos un nuevo
        barrido_de_estado para promediar los valores acumulados.
        El orden en que se realiza esto es importante, pues es importante calcular con
        cada sorteo el costo para los diferentes estados. Los sorteos determinan
        las mquinas que estan disponibles, los aportes a los embalses y los
        recursos disponibles en general. Es importante que para un mismo conjunto
        de recursos disponibles se realice el barrido de los estados y luego con
        otro conjunto para salvaguardar la monotona esperable de los costos de
        una etapa respecto de las variables de estado.
        *)
          // borro el frame pues lo voy a usar para acumular
          globs.CF.constelacion.ClearFrame(globs.kPaso_);
          globs.ClearAuxs1;
          for kCron := 1 to globs.NCronicasOpt do
          begin
            globs.kCronica := kCron;
            globs.procNot(globs.procNot_opt_InicioCronicaSorteos);
            SorteosDelPasoOpt(True);
            // Aqui hacemos el barrido de los estados
            // nos posicionamos en la primer estrella
            vclear(globs.CF.estrella_kr);
            vclear(globs.CF.estrella_kd);
            NoFinBarridoEstrellas := True;
            while NoFinBarridoEstrellas do
            begin
              globs.CF.SetEstadoToEstrella; // Fijamos la estrella
              PosicionarseEnEstrellita;     // Fijamos el estado en los actores
              Fuentes_PrepararPaso_ps;

{$IFDEF ITERAR}
              globs.cntIteracionesDelPaso := 0;
              repeat
                Inc(globs.cntIteracionesDelPaso);
{$ENDIF}

                // if (globs.kPaso_ = 840) and (globs.CF.ordinalEstrellaActual = 12 )  then
                //  writeln('kpaso: ', globs.kPaso_, ', kEstrellita: ', globs.CF.ordinalEstrellaActual,' cnt_iter: ', globs.cntIteracionesDelPaso, ' kCron: ', kCron );

                Actores_PrepararPaso_ps;

{$IFDEF DUMP_TEXT_OPTRES}
                if kCron = 1 then
{$IFDEF ITERAR}
                  if globs.cntIteracionesDelPaso = 1 then
{$ENDIF}
                    for k := 0 to high(fsal_opt) do
                    begin
                      //                TActor(Self.lst_opt_PrintResultados.items[k]).PosicionarseEnEstrellita;
                      //                TActor(Self.lst_opt_PrintResultados.items[k]).prepararPaso_ps;
                      TActor(self.lst_opt_PrintResultados.Items[k]).opt_PrintResultados(
                        fsal_opt[k]);
                    end;
{$ENDIF}

                ResolverPaso;
{$IFDEF ITERAR}
              until (globs.cntIteracionesDelPaso >= globs.NMAX_ITERACIONESDELPASO_OPT) or
                (not NecesitoIterar);
{$ENDIF}

              EvolucionarEstado;
              CostoFuturo_cronica := CostoDelPaso_masCF_llegada;

              globs.CF.AcumCostoEstrella(globs.kPaso_, CostoFuturo_Cronica *
                globs.invNCronicasOpt);
              Actores_AcumularAuxs1;
{$IFDEF MIPSimplex}
{$IFDEF SPXMEJORCAMINO}
              vswap(spx.mejorCaminoEsperado, spx.mejorCaminoEncontrado);
{$ENDIF}
{$ENDIF}
              NoFinBarridoEstrellas := globs.CF.incEstrella; // pasamos a la siguiente estrella

            end; // while de las estrellas
          end; // for de las crnicas
          //        globs.MultAuxs1( 1 / globs.NCronicasOpt );

{$IFDEF DUMP_TEXT_OPTRES}
          vclear(globs.CF.estrella_kr);
          vclear(globs.CF.estrella_kd);
          NoFinBarridoEstrellas := True;
          while NoFinBarridoEstrellas do
          begin
            Write(fsal, #9, FloatToStrF(globs.CF.costoEstrella(globs.kPaso_),
              ffGeneral, 6, 2));
            NoFinBarridoEstrellas := globs.CF.incEstrella;
          end;
{$ENDIF}
        end // fin de la optimizacin Cronizada
        else
        begin // incio: optimizacin con valores esperados
          globs.kCronica := 0; // ponemos a cero para que sea en valor esperado

          SorteosDelPasoOpt(False);
          // Aqui hacemos el barrido de los estados
          // nos posicionamos en la primer estrella
          vclear(globs.CF.estrella_kr);
          vclear(globs.CF.estrella_kd);
          NoFinBarridoEstrellas := True;
          while NoFinBarridoEstrellas do
          begin
            // fijamos el estado
            globs.CF.SetEstadoToEstrella;
            PosicionarseEnEstrellita;// Fijamos el estado en los actores

            //          CF_Base:= globs.CF.costoEstrella(globs.kPaso_+1);

            Fuentes_PrepararPaso_ps;
{$IFDEF ITERAR}
            globs.cntIteracionesDelPaso := 0;
            repeat
              Inc(globs.cntIteracionesDelPaso);
{$ENDIF}
              Actores_PrepararPaso_ps;
              ResolverPaso;
{$IFDEF ITERAR}
            until (globs.cntIteracionesDelPaso >= globs.NMAX_ITERACIONESDELPASO_OPT) or
              (not NecesitoIterar);
{$ENDIF}
            EvolucionarEstado;
            CostoFuturo_Esperado := CostoDelPaso_masCF_llegada;

            globs.CF.SetCostoEstrella(globs.kPaso_, CostoFuturo_Esperado);
            Actores_SetAuxs1;

{$IFDEF DUMP_TEXT_OPTRES}
            Write(fsal, #9, FloatToStrF(CostoFuturo_Esperado, ffGeneral, 6, 2));
            for k := 0 to high(fsal_opt) do
              TActor(self.lst_opt_PrintResultados.Items[k]).opt_PrintResultados(fsal_opt[k]);
{$ENDIF}
{$IFDEF MIPSimplex}
{$IFDEF SPXMEJORCAMINO}
            vswap(spx.mejorCaminoEsperado, spx.mejorCaminoEncontrado);
{$ENDIF}
{$ENDIF}
            NoFinBarridoEstrellas := globs.CF.incEstrella;
          end;// barrido estrellas
        end;
{$IFDEF DUMP_TEXT_OPTRES}
        writeln(fsal);
        for k := 0 to high(fsal_opt) do
          writeln(fsal_opt[k]);
{$ENDIF}

        globs.Fijar_kPaso(globs.kPaso_ - 1);
        globs.SwapAuxs;
        globs.procNot(globs.procNot_opt_FinCalculosDeEtapa);
      end; // while del paso

      FinOptimizacion;
    finally
{$IFDEF DUMP_TEXT_OPTRES}
      cerrarArchisOptRes(fsal, fsal_opt, fsalopen);
{$ENDIF}
    end;
    if not globs.abortarSim then
    begin
      globs.EstadoDeLaSala := CES_OPTIMIZACION_TERMINADA;
    end
    else
      globs.EstadoDeLaSala := CES_OPTIMIZACION_ABORTADA;
  except
    globs.EstadoDeLaSala := CES_OPTIMIZACION_ABORTADA;
    raise;
  end;
end;



procedure TsalaDeJuego.inicializarArchisOptRes(var fsal: TextFile;
  var fsal_opt: TDAOfTextFile; var fsalopen: boolean);
var
  archi: string;
  k:     integer;
  NoFinBarridoEstrellas: boolean;
begin
  if globs.SortearOpt then
    archi := dirResultadosCorrida + 'optres_' + IntToStr(RandSeedInicial) +
      'x' + IntToStr(globs.NCronicasOpt) + '.xlt'
  else
    archi := dirResultadosCorrida + 'optres_VE.xlt';
  assignfile(fsal, archi);
  {$I-}
  rewrite(fsal);
  {$I+}
  if ioresult <> 0 then
    raise Exception.Create('No es posible crear el archivo: ' + archi);
  fsalopen := True;

  if escribirOptActores then
  begin
    Armar_lst_opt_PrintResultados;
    // aqu ya podemos detectar cuantos hay en lst_PrintResultadosOpt
    setlength(fsal_opt, lst_opt_PrintResultados.Count);
    for k := 0 to high(fsal_opt) do
    begin
      if globs.SortearOpt then
        archi := dirResultadosCorrida + 'opt' +
          TActor(lst_opt_PrintResultados.items[k]).nombre + '_' +
          IntToStr(RandSeedInicial) + 'x' + IntToStr(globs.NCronicasOpt) + '.xlt'
      else
        archi := dirResultadosCorrida + 'opt' +
          TActor(lst_opt_PrintResultados.items[k]).nombre + '_VE.xlt';
      assignfile(fsal_opt[k], archi);
      rewrite(fsal_opt[k]);
    end;
  end
  else
  begin
    SetLength(fsal_opt, 0);
    Armar_lst_opt_PrintResultados;
    for k := 0 to lst_opt_PrintResultados.Count - 1 do
    begin
      if globs.SortearOpt then
        archi := dirResultadosCorrida + 'opt' +
          TActor(lst_opt_PrintResultados.items[k]).nombre + '_' +
          IntToStr(RandSeedInicial) + 'x' + IntToStr(globs.NCronicasOpt) + '.xlt'
      else
        archi := dirResultadosCorrida + 'opt' +
          TActor(lst_opt_PrintResultados.items[k]).nombre + '_VE.xlt';
      DeleteFile(PChar(archi)); { *Converted from DeleteFile*  }
    end;
    lst_opt_PrintResultados.Clear;
  end;

  system.Writeln(fsal, 'Versin del simulador:'#9, vSimSEESimulador);
  for k := 0 to high(fsal_opt) do
    writeln(fsal_opt[k], 'Versin del simulador:'#9, vSimSEESimulador);
  writeln(fsal, 'fActPaso: '#9, FloatToStrF(globs.fActPaso, ffGeneral, 12, 10));
  for k := 0 to high(fsal_opt) do
    writeln(fsal_opt[k], 'fActPaso:'#9, FloatToStrF(globs.fActPaso,
      ffGeneral, 12, 10));
  globs.CF.constelacion.PrintDefsToText(fsal, True);
  for k := 0 to high(fsal_opt) do
    globs.CF.constelacion.PrintDefsToText(fsal_opt[k], False);

  Write(fsal, 'paso\estado'#9'Fecha');
  for k := 1 to globs.CF.nEstrellasPorPuntoT do
    Write(fsal, #9, k);
  writeln(fsal);

  // salvamos el frame del ltimo paso de tiempo
  globs.Fijar_kPaso(globs.kPaso_ + 1);
  Write(fsal, IntToStr(globs.kpaso_) + #9 + globs.FechaInicioDelpaso.AsISOStr);
  globs.Fijar_kPaso(globs.kPaso_ - 1);
  for k := 0 to high(fsal_opt) do
    Write(fsal_opt[k], 'paso\estado'#9'Fecha');

  globs.CF.setEstrellaCERO;
  NoFinBarridoEstrellas := True;
  while NoFinBarridoEstrellas do
  begin
    globs.CF.SetEstadoToEstrella; // Fijamos la estrella
    Write(fsal, #9, FloatToStrF(globs.CF.costoEstrella(globs.kPaso_ + 1)
      , ffGeneral, 6, 2));
    for k := 0 to high(fsal_opt) do
    begin
      TActor(Self.lst_opt_PrintResultados.items[k]).PosicionarseEnEstrellita;
      TActor(Self.lst_opt_PrintResultados.items[k]).prepararPaso_ps;
      TActor(Self.lst_opt_PrintResultados.items[k]).opt_PrintResultados_Encab(
        fsal_opt[k]);
    end;
    NoFinBarridoEstrellas := globs.CF.incEstrella;
  end;// barrido estrellas
  writeln(fsal);
  for k := 0 to high(fsal_opt) do
    writeln(fsal_opt[k]);
end;

procedure TsalaDeJuego.escribirPasoOptRes(var fsal: TextFile;
  var fsal_opt: TDAOfTextFile);
var
  k: integer;
  NoFinBarridoEstrellas: boolean;
begin
  writeln(fsal, IntToStr(globs.kPaso_) + #9 + globs.FechaInicioDelpaso.AsISOStr,
    #9, TDAOfNRealToTabbedString(globs.cf.constelacion.fcosto[globs.kpaso_], 6, 2));

  if escribirOptActores then
  begin
    for k := 0 to high(fsal_opt) do
      Write(fsal_opt[k], IntToStr(globs.kPaso_) + #9 +
        globs.FechaInicioDelpaso.AsISOStr);
    vclear(globs.CF.estrella_kr);
    vclear(globs.CF.estrella_kd);
    NoFinBarridoEstrellas := True;
    while NoFinBarridoEstrellas do
    begin
      globs.CF.SetEstadoToEstrella;
      PosicionarseEnEstrellita;
      for k := 0 to high(fsal_opt) do
      begin
        TActor(Self.lst_opt_PrintResultados.items[k]).PosicionarseEnEstrellita;
        TActor(Self.lst_opt_PrintResultados.items[k]).prepararPaso_ps;
        TActor(Self.lst_opt_PrintResultados.items[k]).opt_PrintResultados(fsal_opt[k]);
      end;
      NoFinBarridoEstrellas := globs.CF.incEstrella;
    end;
    for k := 0 to high(fsal_opt) do
      writeln(fsal_opt[k]);
  end;
end;

procedure TsalaDeJuego.cerrarArchisOptRes(var fsal: TextFile;
  var fsal_opt: TDAOfTextFile; var fsalopen: boolean);
var
  k: integer;
begin
  if fsalopen then
  begin
    for k := 0 to high(fsal_opt) do
      closeFile(fsal_opt[k]);
    if fsalopen then
      closeFile(fsal);
  end;
end;

procedure TSalaDeJuego.printEncabezadoSimRes(var f: TextFile);
var
  iposteres, kactorres: integer;
begin
  system.Writeln(f, 'Versin del simulador:'#9, vSimSEESimulador);
  system.writeln(f, 'Inicio simulacin: '#9, DateTimeToIsoStr(now()));
  system.Writeln(f, 'FechaIniSim:'#9, globs.fechaIniSim.AsISOStr,
    #9'FechaFinSim:'#9, globs.fechaFinSim.AsISOStr);
  system.writeln(f, 'NCronicas:'#9, globs.NCronicasSim);
  system.writeln(f, 'NPasos:'#9, globs.nPasos);
  system.writeln(f, 'NPostes:'#9, length(globs.Durpos));
  system.Write(f, 'DurPos[h]:');
  for iposteres := 0 to high(globs.DurPos) do
    Write(f, #9, globs.DurPos[iposteres]: 6: 0);
  system.writeln(f);
  system.writeln(f, 'NActores:'#9, length(actores));
  TActor.printEncabezadosResumenSim(f);
  for kactorres := 0 to high(actores) do
    actores[kactorres].printResumenSim(f);
end;

procedure TSalaDeJuego.printFinalSimRes(var f: TextFile);
begin
  system.writeln(f, 'Fin simulacin:'#9, DateTimeToIsoStr(now()));
end;

{$IFDEF ESTABILIZAR_FRAMEINICIAL}
procedure TSalaDeJuego.EstabilizarFrameInicial;
const
  MAX_CANT_ITERS = 100;
var
  NoFinBarridoEstrellas: boolean;

  //cociente sera costok+1/costok
  cociente: NReal;
  maxCociente: NReal;
  CostoFuturo_Esperado, CostoDelPaso_Simplex: NReal;
  //  CF_Base: NReal;
  cntIters: integer;
  stop: boolean;
begin
  cntIters := 0;
  stop     := False;
  globs.kCronica := 0;
  while (not stop) and (cntIters < MAX_CANT_ITERS) do
  begin
    maxCociente := -MaxNReal;
    //PosicionarseEnPrimerEstrella
    vclear(globs.CF.estrella_kr);
    vclear(globs.CF.estrella_kd);
    NoFinBarridoEstrellas := True;

    PrepararPaso_PreSorteo;
    SorteosDelPasoOpt(False);
    while NoFinBarridoEstrellas do
    begin
      // fijamos el estado
      globs.CF.SetEstadoToEstrella;
      barridoFijarEstadoDeActoresYFuentesToEstrellaOpt;// Fijamos el estado en los actores

      //      CF_Base:= globs.CF.costoEstrella(globs.kPaso_+1);

{$IFDEF ITERAR}
      globs.cntIteracionesDelPaso := 0;
      repeat
        Inc(globs.cntIteracionesDelPaso);
{$ENDIF}
        PrepararPaso_PostSorteo;
        CostoDelPaso_Simplex := ResolverPaso;
{$IFDEF ITERAR}
      until (globs.cntIteracionesDelPaso >= NMAX_ITERACIONESDELPASO) or
        (not NecesitoIterar);
{$ENDIF}
      EvolucionarEstado;

      CostoFuturo_Esperado := CostoDelPaso_masCF_llegada;

      globs.CF.SetCostoEstrella(globs.kPaso_, CostoFuturo_Esperado);
      Actores_SetAuxs1;
      globs.SwapAuxs;
{$IFDEF MIPSimplex}
{$IFDEF SPXMEJORCAMINO}
      vswap(spx.mejorCaminoEsperado, spx.mejorCaminoEncontrado);
{$ENDIF}
{$ENDIF}
      NoFinBarridoEstrellas := globs.CF.incEstrella;

      if CF_Base <> 0 then
        cociente := CostoFuturo_Esperado / CF_Base
      else
        cociente := MaxNReal;

      if cociente > maxCociente then
        maxCociente := cociente;
    end;// barrido estrellas

    vswap(globs.CF.constelacion.fCosto[globs.kPaso_],
      globs.CF.constelacion.fCosto[globs.kPaso_ + 1]);
    if (maxCociente < 1.05) and (maxCociente > 0.95) then
      stop := True;
    Inc(cntIters);
  end;
  if not stop then
    globs.Alerta(Self.Nombre + ': Estabilizar frame inicial no convergio');
end;

{$ENDIF}

procedure AlInicio;
begin
  registrarClaseDeCosa(TSalaDeJuego.ClassName, TSalaDeJuego);
end;

procedure AlFinal;
begin
end;


end.

